program GCON;

// Version 1.04 vom 26.04.2013

Device = mega644P;


CONST

  BAUDRATE : WORD = 25253;

  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((25253*8)+20000000)/(25253*16))-1) = ((202024+20000000)/404048)-1 =
  // (20202024/404048)-1 = 50-1 = 49
  UBRR_VAL : WORD = 49;

  XON  : Byte = $11;
  XOFF : Byte = $13;

  Zeichenbreite : Word = 6;
  Zeichenhoehe  : Word = 10; { 8 + 2 = 10 }

  X_ANF : Word = 12;
  Y_ANF : Word = 1;

  max_Spalten : Word = 79; { 0..79 = 80 } 
  max_Zeilen  : Word = 23; { 0..23 = 24 } 


  cl_White  : Byte = $FF; // %11111111
  cl_Black  : Byte = $00; // %00000000
  cl_Red    : Byte = $43; // %11000011
  cl_Green  : Byte = $4C; // %11001100
  cl_Blue   : Byte = $B0; // %11110000
  cl_Yellow : Byte = $4F; // %11001100
  cl_Purple : Byte = $73; // %11001100
  cl_Aqua   : Byte = $7C; // %11001100
  cl_Gray   : Byte = $6A; // %10111111



  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par       : Byte = 3;
  IBM_CSI_TM_Par_Zeile : Byte = 4;
  IBM_CSI_TM_Par_Xterm : Byte = 5;
  IBM_GRAPHIC_TM       : Byte = 6;
  IBM_GRAPHIC_P2_TM    : Byte = 7;


// Font fuer 6x8 Zeichen
{$I font6x8.INC}

// Icon 64x64
{$I BILD.INC}

{--------------------------------------------------------------}




var


{$I Register_mega644P.INC}



  // Globale Variablen

  A16[PortD, 2]     : bit; // A
  WE[PortD, 3]      : bit; // A
  OE[PortD, 4]      : bit; // A
  VS1_GS2[PortD, 5] : bit; // A
  DIR[PortD, 6]     : bit; // A
  LED_GN[PortD, 7]  : bit; // A

 
  FCOLOR, BCOLOR, PIXCOLOR,
  Zeichen : Byte;

  X_KUR_POS, Y_KUR_POS,
  X_PIX_POS, Y_PIX_POS,
  X_END_POS, Y_END_POS,
  Kursor_Schleife: Word;

  Kursor_Ein, KurArr_Aktuell : Boolean;

  Kursor_Array : Array [0..47] of Byte;

  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2 : Word;

  delta_x, delta_y : Word;


{--------------------------------------------------------------}
{ functions }


// *** INITIALISIERUNG ***

procedure InitPorts;
begin
{
Grafik-Controller (GCON) (ATmega1284P-PU)
=================

D0..D7 = 8 (A0..A7)
A0..A16 = 17 (B0..B7, C0..C7, D2)


RX = 1 (D0)
TX = 1 (D1)

/WE = 1 (D3)
/OE = 1 (D4)

/VS1_GS2 = 1 (D5)
(0 = Counter (V) auf S1, Controller (G) auf S2)
(1 = Counter (V) auf S2, Controller (G) auf S1)

DIR = 1 (D6)

LED_GN = 1 (D7)

Summe = 32

}

  DDRA:=  %00000000;
  DDRB:=  %11111111;
  DDRC:=  %11111111;


// LED_GN = 1 (D7),/CE = 1 (D6),/VS1_GS2 = 0 (D5),/OE = 1 (D4),
// /WE = 1 (D3),A16  (D2),TX0 (D1),RX0 (D0)
  DDRD:=  %11111110;
  PORTD:= %01011000;

end InitPorts;




procedure INIT_SER_PORT;
begin

    UBRR0 := UBRR_VAL;

    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;






// *** Basis-Programme ***








PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;






function Random : Byte;
var
  Wert : Byte;
begin



  Return(Wert);
end Random;





procedure clear_RAM;
VAR
  x1: Word;
  x2 : Word;
  Adresse : Word;

begin
  ClearBit(A16);
  ClearBit(DIR);

  DDRA:=  %11111111;
  PortA:= BCOLOR;

  SetBit(WE);

  Adresse:=0;

  for x1:=0 to 255 do

    for x2:=0 to 511 do
      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);
      ClearBit(WE);
      Inc(Adresse);
      SetBit(WE);
    endfor;

    if Adresse=0 then
      SetBit(A16);
    endif;

  endfor;

  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end clear_RAM;




procedure ScreenRoll;
begin

{$I ScreenRoll.inc}

end ScreenRoll;





procedure toggle_RAMPAGE;
begin

  if BitHigh(VS1_GS2) then
    ClearBit(VS1_GS2);
  else
    SetBit(VS1_GS2);
  endif;

end toggle_RAMPAGE;






procedure Reset_Form;
begin

  FCOLOR:= cl_Black;
  BCOLOR:= cl_White;
  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_ANF;

  clear_RAM;
  toggle_RAMPAGE;
  clear_RAM;
  toggle_RAMPAGE;

end Reset_Form;



// ***********************
// *** Grafik-Ausgabe  ***
// ***********************



procedure write_Bild;
VAR
  x1: Byte;
  x2 : Byte;
  B_Wert : Byte;
  Adresse : Word;
  B_Pointer : Word;

begin
  ClearBit(A16);
  ClearBit(DIR);

  DDRA:=  %11111111;

  SetBit(WE);

  Adresse:=Y_PIX_POS*512;
  Adresse:=Adresse+X_PIX_POS;

  B_Pointer:=0;

  for x1:=0 to 63 do

    for x2:=0 to 63 do

      B_Wert:=BILD[B_Pointer];

      PortA:= B_Wert;
      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);
      ClearBit(WE);
      Inc(Adresse);
      SetBit(WE);

      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);
      ClearBit(WE);
      Inc(Adresse);
      Inc(B_Pointer);
      SetBit(WE);

    endfor;

    Adresse:=Adresse+384;

  endfor;

  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end write_Bild;





procedure init_Bild;
begin

 // Bild zeichnen
  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_ANF;
  write_Bild;
  toggle_RAMPAGE;

  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_ANF;
  write_Bild;
  toggle_RAMPAGE;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 7;

  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_KUR_POS*10;
  Y_PIX_POS:= Y_PIX_POS+Y_ANF;

end init_Bild;





procedure SET_POINT;
VAR
  Adresse : Word;

begin

  if Y_PIX_POS>127 then
     // Berechnung der Adresse (1.Pixel)
     Adresse:=Y_PIX_POS-128;
     Adresse:=Adresse*512;
     Adresse:=Adresse+X_PIX_POS;
     SetBit(A16);
  else
     // Berechnung der Adresse (1.Pixel)
     Adresse:=Y_PIX_POS*512;
     Adresse:=Adresse+X_PIX_POS;
     ClearBit(A16);
  endif;

  ClearBit(DIR);

  DDRA:=  %11111111;

  SetBit(WE);

  PortA:=PIXCOLOR;

  PORTB:= Low(Adresse);
  PORTC:= High(Adresse);
  ClearBit(WE);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end SET_POINT;



procedure GrafikDrawPoint;
begin

  SET_POINT;
  toggle_RAMPAGE;

  SET_POINT;
  toggle_RAMPAGE;

end GrafikDrawPoint;






procedure SET_POINT_POS(X_POINT_POS, Y_POINT_POS : Word);
VAR
  Adresse : Word;

begin

  if Y_POINT_POS>127 then
     // Berechnung der Adresse (1.Pixel)
     Adresse:=Y_POINT_POS-128;
     Adresse:=Adresse*512;
     Adresse:=Adresse+X_POINT_POS;
     SetBit(A16);
  else
     // Berechnung der Adresse (1.Pixel)
     Adresse:=Y_POINT_POS*512;
     Adresse:=Adresse+X_POINT_POS;
     ClearBit(A16);
  endif;

  ClearBit(DIR);

  DDRA:=  %11111111;

  SetBit(WE);

  PortA:=PIXCOLOR;

  PORTB:= Low(Adresse);
  PORTC:= High(Adresse);
  ClearBit(WE);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end SET_POINT_POS;





// zeichnet eine Linie zwischen den Punkten:
// P1(X_PIX_POS,Y_PIX_POS) und P2(X_END_POS,Y_END_POS)
procedure LINE_TO;
var
  x1 : Word;
  xp_anf : Word;
  xp_end : Word;
  y1 : Word;
  yp_anf : Word;
  yp_end : Word;

begin

  // da ohne Vorzeichen gearbeitet wird muss
  // als Erstes festgestellt werden, welcher
  // X-Wert groesser ist ...
  if X_PIX_POS<X_END_POS then
    delta_x:=X_END_POS-X_PIX_POS;
    xp_anf:=X_PIX_POS;
    xp_end:=X_END_POS;
  else
    delta_x:=X_PIX_POS-X_END_POS;
    xp_anf:=X_END_POS;
    xp_end:=X_PIX_POS;
  endif;

  // ... und welcher Y-Wert groesser ist
  if Y_PIX_POS<Y_END_POS then
    delta_y:=Y_END_POS-Y_PIX_POS;
    yp_anf:=Y_PIX_POS;
    yp_end:=Y_END_POS;
  else
    delta_y:=Y_PIX_POS-Y_END_POS;
    yp_anf:=Y_END_POS;
    yp_end:=Y_PIX_POS;
  endif;

  // die Schleife laeuft am Besten entlang der
  // laengeren Seite
  if delta_x>delta_y then

    // Ausnahmebehandlung: Y_PIX_POS=Y_END_POS (waagerechter Strich)
    if delta_y=0 then
      // Durchlaufen aller X-Werte
      for x1:=xp_anf to xp_end do
        SET_POINT_POS(x1,Y_PIX_POS);
      endfor;
    else

      if delta_y>127 then
        SHR(delta_x);
        SHR(delta_y);
      endif;

      if delta_x>0 then

         // Durchlaufen aller x-Werte
        for x1:=xp_anf to xp_end do

          // aktueller x-Wert mal Anstiegsfaktor ergibt den
          // aktuellen y-Wert
          y1:=x1*delta_y;
          y1:=y1 DIV delta_x;
          y1:=y_anf+y1;

          SET_POINT_POS(x1,y1);
        endfor;

      endif; { if delta_x>0 then }

    endif; { if delta_y=0 then }
  else

    // Ausnahmebehandlung: X_PIX_POS=X_END_POS (senkrechter Strich)
    if delta_x=0 then

      // Durchlaufen aller y-Werte
      for y1:=yp_anf to yp_end do
        SET_POINT_POS(X_PIX_POS,y1);
       endfor;

    else

      if delta_x>127 then
        SHR(delta_x);
        SHR(delta_y);
      endif;

      if delta_y>0 then

        // Durchlaufen aller y-Werte
        for y1:=yp_anf to yp_end do

          // aktueller y-Wert mal Anstiegsfaktor ergibt den
          // aktuellen x-Wert
          x1:=y1*delta_x;
          x1:=x1 DIV delta_y;
          x1:=x_anf+x1;

          SET_POINT_POS(x1,y1);
        endfor;

      endif; { if delta_y>0 then }

    endif; { if delta_x=0 then }

  endif; { if delta_x>delta_y then }

end LINE_TO;






procedure GrafikDrawLine;
begin

  LINE_TO;
  toggle_RAMPAGE;

  LINE_TO;
  toggle_RAMPAGE;

  X_PIX_POS:=X_END_POS;
  Y_PIX_POS:=Y_END_POS;

end GrafikDrawLine;













procedure DRAW_REC;
VAR
  Adresse : Word;
  w1 : Word;
  YR_POS : Word;
begin

  if Y_PIX_POS>127 then
     // Berechnung der Adresse (1.Pixel)
     YR_POS:=Y_PIX_POS-128;
     Adresse:=YR_POS;
     Adresse:=Adresse*512;
     Adresse:=Adresse+X_PIX_POS;
     SetBit(A16);
  else
     // Berechnung der Adresse (1.Pixel)
     YR_POS:=Y_PIX_POS;
     Adresse:=Y_PIX_POS*512;
     Adresse:=Adresse+X_PIX_POS;
     ClearBit(A16);
  endif;

  ClearBit(DIR);

  DDRA:=  %11111111;

  SetBit(WE);

  PortA:=PIXCOLOR;






  // oberer waagerechter Strich
  for w1:=X_PIX_POS to X_END_POS do

    PORTB:= Low(Adresse);
    PORTC:= High(Adresse);
    ClearBit(WE);
    INC(Adresse);
    SetBit(WE);

  endfor;

  DEC(Adresse);

  // rechter senkrechter Strich
  for w1:=Y_PIX_POS to Y_END_POS do

    Adresse:=Adresse+512;

    INC(YR_POS);
    if YR_POS=128 then
      YR_POS:=0;
      SetBit(A16);
      Adresse:=X_END_POS;
    endif;

    PORTB:= Low(Adresse);
    PORTC:= High(Adresse);
    ClearBit(WE);
    NOP;
    NOP;
    NOP;
    NOP;
    SetBit(WE);

  endfor;




  if Y_PIX_POS>127 then
     // Berechnung der Adresse (1.Pixel)
     YR_POS:=Y_PIX_POS-128;
     Adresse:=YR_POS;
     Adresse:=Adresse*512;
     Adresse:=Adresse+X_PIX_POS;
     SetBit(A16);
  else
     // Berechnung der Adresse (1.Pixel)
     YR_POS:=Y_PIX_POS;
     Adresse:=Y_PIX_POS*512;
     Adresse:=Adresse+X_PIX_POS;
     ClearBit(A16);
  endif;




  // linker senkrechter Strich
  for w1:=Y_PIX_POS to Y_END_POS do

    Adresse:=Adresse+512;

    INC(YR_POS);
    if YR_POS=128 then
      YR_POS:=0;
      SetBit(A16);
      Adresse:=X_PIX_POS;
    endif;

    PORTB:= Low(Adresse);
    PORTC:= High(Adresse);
    ClearBit(WE);
    NOP;
    NOP;
    NOP;
    NOP;
    SetBit(WE);

  endfor;



  // unterer waagerechter Strich
  for w1:=X_PIX_POS to X_END_POS do

    PORTB:= Low(Adresse);
    PORTC:= High(Adresse);
    ClearBit(WE);
    INC(Adresse);
    SetBit(WE);

  endfor;



  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end DRAW_REC;







procedure GrafikDrawRectangle;
begin
  DRAW_REC;
  toggle_RAMPAGE;

  DRAW_REC;
  toggle_RAMPAGE;

  X_PIX_POS:=X_END_POS;
  Y_PIX_POS:=Y_END_POS;

end GrafikDrawRectangle;







procedure DRAW_FULL_REC;
VAR
  Adresse : Word;
  w1 : Word;
  w2 : Word;
begin

  ClearBit(DIR);

  DDRA:=  %11111111;

  SetBit(WE);

  PortA:=PIXCOLOR;

  for w2:=Y_PIX_POS to Y_END_POS do

    if w2>127 then
       // Berechnung der Adresse (1.Pixel)
       Adresse:=w2-128;
       Adresse:=Adresse*512;
       Adresse:=Adresse+X_PIX_POS;
       SetBit(A16);
    else
       // Berechnung der Adresse (1.Pixel)
       Adresse:=w2*512;
       Adresse:=Adresse+X_PIX_POS;
       ClearBit(A16);
    endif;

    // waagerechter Strich
    for w1:=X_PIX_POS to X_END_POS do

      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);
      ClearBit(WE);
      INC(Adresse);
      SetBit(WE);

    endfor;




  endfor;

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);

end DRAW_FULL_REC;





procedure GrafikDrawFullRectangle;
begin
  DRAW_FULL_REC;
  toggle_RAMPAGE;

  DRAW_FULL_REC;
  toggle_RAMPAGE;

  X_PIX_POS:=X_END_POS;
  Y_PIX_POS:=Y_END_POS;

end GrafikDrawFullRectangle;











// ***********************
// *** Zeichen-Ausgabe ***
// ***********************



procedure Write_Char;
var
  FontPtr : Word;
  x_cnt : Word;
  y_cnt : Word;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : Word;
begin

  ClearBit(DIR);
  DDRA:= %11111111;

  SetBit(WE);


  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;


  // Sonderfall: Y_KUR_POS=12
  if Y_KUR_POS=12 then

    // Berechnung der Adresse (1.Pixel)
    Adresse:=Y_PIX_POS*512;
    Adresse:=Adresse+X_PIX_POS;
    ClearBit(A16);

    // zuerst nur Y_PIX_POS 121...127
    for y_cnt:=0 to 6 do

      FontZeile:=font6x8[FontPtr];
      INC(FontPtr);
      SHR(FontZeile);
      SHR(FontZeile);

      for x_cnt:=0 to 5 do

        FontColor:=FontZeile and %00000001;
        if FontColor = 0 then
          PORTA:= BCOLOR;
        else
          PORTA:= FCOLOR;
        endif;

        PORTB:= Low(Adresse);
        PORTC:= High(Adresse);

        ClearBit(WE);
        SHR(FontZeile);
        INC(Adresse);
        SetBit(WE);

      endfor; { for x_cnt:=1 to 6 do }
    
      Adresse:=Adresse+506;

    endfor; { for y_cnt:=0 to 6 do }


    // ... dann Y_PIX_POS 128

    // Berechnung der Adresse (1.Pixel)
    Adresse:=X_PIX_POS;
    SetBit(A16);

    FontZeile:=font6x8[FontPtr];
    SHR(FontZeile);
    SHR(FontZeile);

    for x_cnt:=0 to 5 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);

      ClearBit(WE);
      SHR(FontZeile);
      INC(Adresse);
      SetBit(WE);

    endfor; { for y_cnt:=0 to 5 do }


  // Y_KUR_POS<>12 ... der Normalfall
  else
  
    if Y_KUR_POS>12 then
      // Berechnung der Adresse (1.Pixel)
      Adresse:=Y_PIX_POS-128;
      Adresse:=Adresse*512;
      Adresse:=Adresse+X_PIX_POS;
      SetBit(A16);
    else
      // Berechnung der Adresse (1.Pixel)
      Adresse:=Y_PIX_POS*512;
      Adresse:=Adresse+X_PIX_POS;
      ClearBit(A16);
    endif;

    for y_cnt:=0 to 7 do

      FontZeile:=font6x8[FontPtr];
      INC(FontPtr);
      SHR(FontZeile);
      SHR(FontZeile);

      for x_cnt:=0 to 5 do

        FontColor:=FontZeile and %00000001;
        if FontColor = 0 then
          PORTA:= BCOLOR;
        else
          PORTA:= FCOLOR;
        endif;

        PORTB:= Low(Adresse);
        PORTC:= High(Adresse);

        ClearBit(WE);
        SHR(FontZeile);
        INC(Adresse);
        SetBit(WE);

      endfor; { for x_cnt:=0 to 5 do }
    
      Adresse:=Adresse+506;

    endfor; { for y_cnt:=0 to 7 do }

  endif; { if Y_KUR_POS=12 then }

  // Grundeinstellungen
  SetBit(WE);
  DDRA:= %00000000;
  SetBit(DIR);
  SetBit(OE);
  ClearBit(A16);

end Write_Char;








procedure VRAM_to_Puffer;
var
  Adresse : Word;
  x_cnt : Word;
  y_cnt : Word;
  KurPos : Word;
begin

  // Zeichen aus VRAM lesen -> Zeichen in Puffer schreiben
  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);


  // Sonderfall: Y_KUR_POS=12
  if Y_KUR_POS=12 then

    // Berechnung der Adresse (1.Pixel)
    Adresse:=Y_PIX_POS*512;
    Adresse:=Adresse+X_PIX_POS;
    ClearBit(A16);
    KurPos:=0;

    for y_cnt:=0 to 6 do
 
      for x_cnt:=0 to 5 do
 
        PORTB:= Low(Adresse);
        PORTC:= High(Adresse);

        ClearBit(OE);
        INC(Adresse);
        Kursor_Array[KurPos]:=PINA;
        INC(KurPos);
        SetBit(OE);

      endfor; { for x_cnt:=0 to 5 do } 
    
      Adresse:=Adresse+506;

    endfor; { for y_cnt:=0 to 6 do } 


    // ... dann Y_PIX_POS 128

    // Berechnung der Adresse (1.Pixel)
    Adresse:=X_PIX_POS;
    SetBit(A16);

    for x_cnt:=0 to 5 do

      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);

      ClearBit(OE);
      INC(Adresse);
      Kursor_Array[KurPos]:=PINA;
      INC(KurPos);
      SetBit(OE);

    endfor; { for y_cnt:=0 to 5 do }

  else

    if Y_KUR_POS>12 then
      // Berechnung der Adresse (1.Pixel)
      Adresse:=Y_PIX_POS-128;
      Adresse:=Adresse*512;
      Adresse:=Adresse+X_PIX_POS;
      SetBit(A16);
    else
      // Berechnung der Adresse (1.Pixel)
      Adresse:=Y_PIX_POS*512;
      Adresse:=Adresse+X_PIX_POS;
      ClearBit(A16);
    endif;

    KurPos:=0;

    for y_cnt:=0 to 7 do
 
      for x_cnt:=0 to 5 do
 
        PORTB:= Low(Adresse);
        PORTC:= High(Adresse);

        NOP;
        NOP;

        ClearBit(OE);
        INC(Adresse);
        Kursor_Array[KurPos]:=PINA;
        INC(KurPos);
        SetBit(OE);

      endfor; { for x_cnt:=0 to 5 do } 
    
      Adresse:=Adresse+506;

    endfor; { for y_cnt:=0 to 7 do } 

  endif; { if Y_KUR_POS=12 then }

  // VRAM Steuerleitungen auf Grundstellung
  SetBit(WE);
  DDRA:= %00000000;
  SetBit(DIR);
  SetBit(OE);
  ClearBit(A16);

  KurArr_Aktuell:=true;

end VRAM_to_Puffer;






procedure Puffer_to_VRAM;
var
  Adresse : Word;
  x_cnt : Word;
  y_cnt : Word;
  KurPos : Word;
begin

  if KurArr_Aktuell then

    // Zeichen aus Puffer lesen -> in VRAM schreiben
    ClearBit(A16);
    ClearBit(DIR);

    DDRA:=  %11111111;

    // Sonderfall: Y_KUR_POS=12
    if Y_KUR_POS=12 then

      // Berechnung der Adresse (1.Pixel)
      Adresse:=Y_PIX_POS*512;
      Adresse:=Adresse+X_PIX_POS;
      ClearBit(A16);
      KurPos:=0;

      for y_cnt:=0 to 6 do
 
        for x_cnt:=0 to 5 do
 
          PORTA:= Kursor_Array[KurPos];
          PORTB:= Low(Adresse);
          PORTC:= High(Adresse);

          ClearBit(WE);
          INC(Adresse);
          INC(KurPos);
          SetBit(WE);

        endfor; 
    
        Adresse:=Adresse+506;

      endfor; 

      // ... dann Y_PIX_POS 128
 
      // Berechnung der Adresse (1.Pixel)
      Adresse:=X_PIX_POS;
      SetBit(A16);

      for x_cnt:=0 to 5 do
  
        PORTA:= Kursor_Array[KurPos];
        PORTB:= Low(Adresse);
        PORTC:= High(Adresse);

        ClearBit(WE);
        INC(Adresse);
        INC(KurPos);
        SetBit(WE);

      endfor; { for x_cnt:=0 to 5 do }

    else

      if Y_KUR_POS>12 then
        // Berechnung der Adresse (1.Pixel)
        Adresse:=Y_PIX_POS-128;
        Adresse:=Adresse*512;
        Adresse:=Adresse+X_PIX_POS;
        SetBit(A16);
      else
        // Berechnung der Adresse (1.Pixel)
        Adresse:=Y_PIX_POS*512;
        Adresse:=Adresse+X_PIX_POS;
        ClearBit(A16);
      endif; { if Y_KUR_POS>12 then }

      KurPos:=0;

      for y_cnt:=0 to 7 do
 
        for x_cnt:=0 to 5 do
 
          PORTA:= Kursor_Array[KurPos];
          PORTB:= Low(Adresse);
          PORTC:= High(Adresse);

          ClearBit(WE);
          INC(Adresse);
          INC(KurPos);
          SetBit(WE);

        endfor; { for x_cnt:=0 to 5 do }
    
        Adresse:=Adresse+506;

      endfor; { for y_cnt:=0 to 7 do }

    endif; { else Y_KUR_POS=12 then }

    // Grundeinstellungen
    SetBit(WE);
    DDRA:= %00000000;
    SetBit(DIR);
    SetBit(OE);
    ClearBit(A16);

  endif; { if KurArr_Aktuell then }

end Puffer_to_VRAM;








procedure Schalte_Kursor_Ein;
begin

  VRAM_to_Puffer;

  // Kursor schreiben
  Zeichen:=$5F;
  Write_Char;
  toggle_RAMPAGE;
  Write_Char;
  toggle_RAMPAGE;

end Schalte_Kursor_Ein;





procedure Schalte_Kursor_Aus;
begin

  Puffer_to_VRAM;
  toggle_RAMPAGE;
  Puffer_to_VRAM;
  toggle_RAMPAGE;

end Schalte_Kursor_Aus;




// *** Hilfsprogramme fuer CONOUT ***



// Loeschen von Kursorpossition bis zum Zeilenende
procedure DELETE_EOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=  X_PIX_POS;

  for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

  for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_EOL;






// Loeschen von Anfang bis Kursorpossition
procedure DELETE_BOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to X_KUR_POS2 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to X_KUR_POS2 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_BOL;







// Loeschen der gesammten Zeile
procedure DELETE_LINE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to 79 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to 79 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+6;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  toggle_RAMPAGE;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_LINE;



















// 
procedure DELETE_LINE_SCR_ROLL;
VAR
  x1: Word;
  y1 : Word;
  Adresse_von : Word;
  Adresse_bis : Word;

begin

 {

  ClearBit(A16);
  ClearBit(DIR);

  DDRA:=  %11111111;
  PortA:= BCOLOR;

  SetBit(WE);

  Adresse:=0;

  for y1:=0 to 255 do

    for x1:=0 to 511 do
      PORTB:= Low(Adresse);
      PORTC:= High(Adresse);
      ClearBit(WE);
      Inc(Adresse);
      SetBit(WE);
    endfor;

    if Adresse=0 then
      SetBit(A16);
    endif;

  endfor;

  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);








  toggle_RAMPAGE;


              }




end DELETE_LINE_SCR_ROLL;















// 
procedure INSERT_LINE_SCR_ROLL;
begin


end INSERT_LINE_SCR_ROLL;




procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>79 then
    X_KUR_POS:=79;
  endif;

  X_PIX_POS:=X_KUR_POS*6;
  X_PIX_POS:=X_PIX_POS+X_ANF;


  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>23 then
    Y_KUR_POS:=23;
  endif;

  Y_PIX_POS:=Y_KUR_POS*10;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

end SET_CURSOR_POSITION; 



// Erhoeht die Kursorposition der aktuellen Zeile um 1 
//     (wenn die max_Spalten noch nicht erreicht ist) 
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten then
    Inc(X_KUR_POS);
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endif;

end CURSOR_RIGHT;



procedure WriteLn_Char_RP;
begin
  Write_Char;
  toggle_RAMPAGE;
  Write_Char;
  toggle_RAMPAGE;
  CURSOR_RIGHT;
end WriteLn_Char_RP;




// *********************

// *** TERMINAL MODE ***

// *********************




procedure Fehler_ESC;
begin
  Zeichen:=$45; // E
  WriteLn_Char_RP;

  Zeichen:=$53; // S
  WriteLn_Char_RP;

  Zeichen:=$43; // C
  WriteLn_Char_RP;

  TermMode:=Normal_TM;

end Fehler_ESC;



procedure Fehler_ESC_mZ;
var
  lok_Zeichen : Byte;
begin

  lok_Zeichen:=Zeichen;
  Fehler_ESC;
  Zeichen:=lok_Zeichen;
  WriteLn_Char_RP;

end Fehler_ESC_mZ;





procedure Fehler_ESC_CSI;
begin

  Fehler_ESC;

  Zeichen:=$5B; // [
  WriteLn_Char_RP;

end Fehler_ESC_CSI;




procedure Fehler_ESC_CSI_mZ;
var
  lok_Zeichen : Byte;
begin

  lok_Zeichen:=Zeichen;
  Fehler_ESC_CSI;
  Zeichen:=lok_Zeichen;
  WriteLn_Char_RP;

  CSI_Parameter1:=0;
  CSI_Parameter2:=0;

end Fehler_ESC_CSI_mZ;




procedure Fehler_ESC_CSI_Par;
begin

  Fehler_ESC_CSI;

  // nur fuer Parameter unter 10 !!!!!!!!!!!
  Zeichen:=Low(CSI_Parameter1);
  Zeichen:=Zeichen+$30;
  WriteLn_Char_RP;

end Fehler_ESC_CSI_Par;




procedure Fehler_ESC_CSI_Par_mZ;
var
  lok_Zeichen : Byte;
begin

  lok_Zeichen:=Zeichen;
  Fehler_ESC_CSI_Par;
  Zeichen:=lok_Zeichen;
  WriteLn_Char_RP;

  CSI_Parameter1:=0;
  CSI_Parameter2:=0;

end Fehler_ESC_CSI_Par_mZ;




procedure Fehler_ESC_CSI_Par_Zeile;
begin

  Fehler_ESC_CSI_Par;
  Zeichen:=$3B;  // ;
  WriteLn_Char_RP;

  // nur fuer Parameter unter 10 !!!!!!!!!!!
  Zeichen:=Low(CSI_Parameter2);
  Zeichen:=Zeichen+$30;
  WriteLn_Char_RP;

end Fehler_ESC_CSI_Par_Zeile;




procedure Fehler_ESC_CSI_Par_Zeile_mZ;
var
  lok_Zeichen : Byte;
begin

  lok_Zeichen:=Zeichen;
  Fehler_ESC_CSI_Par_Zeile;
  Zeichen:=lok_Zeichen;
  WriteLn_Char_RP;

  CSI_Parameter1:=0;
  CSI_Parameter2:=0;

end Fehler_ESC_CSI_Par_Zeile_mZ;






procedure Normal_Terminal_Mode;
begin


  case Zeichen of

    $0A :   // 0A = Zeilenschaltung (Line Feed)
            // Y_KUR_POS von 0..23 = 24 Zeilen pro Bildschirm
            if Y_KUR_POS<23 then
              INC(Y_KUR_POS);
              Y_PIX_POS:= Y_PIX_POS+10;
            else
              ScreenRoll;
              toggle_RAMPAGE; 
              ScreenRoll;
              toggle_RAMPAGE;
            endif;
 
    |

   $0C :    // 0C = Bildschirm loeschen (Clear Screen)
            clear_RAM;
            toggle_RAMPAGE;
            clear_RAM;
            toggle_RAMPAGE;
 
    |

    $0D :   // 0D = Wagenruecklauf (Carridge Return)
            X_KUR_POS:=0;
            X_PIX_POS:=X_ANF;
 
    | 

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    | 

  else


    if Zeichen>=$20 then
      if Zeichen<=$7F then
        if X_KUR_POS<80 then

          Write_Char;
          toggle_RAMPAGE;
          Write_Char;
          toggle_RAMPAGE;
          INC(X_KUR_POS);
          X_PIX_POS:= X_PIX_POS+6;

          VRAM_to_Puffer;
          Kursor_Ein:=false;
          Kursor_Schleife:=0;
          KurArr_Aktuell:=true;


        endif; { if X_KUR_POS<80 then } 
      endif; { if Zeichen<=$7F then } 
    endif; { if Zeichen>=$20 then  }


  endcase; { case Zeichen of }



end Normal_Terminal_Mode;
  
  



procedure IBM_ESC_Terminal_Mode;
begin

  case Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [ 
    |

    $47 : TermMode:=IBM_GRAPHIC_TM; // GRAPHIC-Mode = ESC G
    |

  else

    Fehler_ESC_mZ;
    TermMode:=Normal_TM;

  endcase;

end IBM_ESC_Terminal_Mode;






procedure IBM_CSI_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=ByteToWord(Zeichen)-$30;
               TermMode:=IBM_CSI_TM_Par;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL; 
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |

    $66 : // Schirm loeschen = ESC [ f
          Reset_Form;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |

  else

    Fehler_ESC_CSI_mZ;
 
  endcase; { case Zeichen of }

end IBM_CSI_Terminal_Mode;




// IBM_CSI_TM_Par
procedure IBM_CSI_Par_Terminal_Mode;
var
  Zaehler : Word;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par;
    |

    $3B : 	// ";" 
	         // ESC [ Pn1 ; PN2 H oder 
	         // ESC [ Pn1 ; PN2 f
	         // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	         // Xterm 256 colors - ESC[38;5;FCOLOR m
          TermMode:=IBM_CSI_TM_Par_Zeile;

    |

    $4A : // Zeilen loeschen = ESC [ Pn J

          case CSI_Parameter1 of
 
            2 : // Loeschen gesammte zeile
                Reset_Form;

            |
          else
            Fehler_ESC_CSI_Par_mZ; 
          endcase;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |


    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Löschen bis Zeilenende
                DELETE_EOL; 
            |

            1 : // Löschen von Anfang bis Kursor
                DELETE_BOL; 
            |

            2 : // Löschen gesammte zeile
                DELETE_LINE;
            |

          else
            Fehler_ESC_CSI_Par_mZ;
          endcase;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |


   $4D : // DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |


    $6D : // Character Attributes = ESC [ Pn m

          case CSI_Parameter1 of

            // *** Textattribute ***


            // ESC [ 0 m = Alle Attribute AUS
            0 : FCOLOR:=cl_Gray;
             //   FCOLOR:=cl_Gray;
             //   BCOLOR:=cl_White;
            |

            // ESC [ 4 m = Unterstreichen
            4 : FCOLOR:=cl_Purple;
            |

           // ESC [ 5 m = Blinken EIN
            5 : FCOLOR:=cl_Red;
            |

            // ESC [ 7 m = Invertierte Darstellung
            7 : FCOLOR:=cl_Black;
             //   FCOLOR:=cl_White;
             //   BCOLOR:=cl_Gray;
            |



            // *** Vordergrundfarben ***

            // ESC [ 30 m = Vordergrundfarbe - 30 Schwarz
            30 : FCOLOR:=cl_Black;
            |

            // ESC [ 31 m = Vordergrundfarbe - 31 Rot
            31 : FCOLOR:=cl_Red;
            |

           // ESC [ 32 m = Vordergrundfarbe - 32 Grün
            32 : FCOLOR:=cl_Green;
            |

            // ESC [ 33 m = Vordergrundfarbe - 33 Gelb
            33 : FCOLOR:=cl_Yellow;
            |

            // ESC [ 34 m = Vordergrundfarbe - 34 Blau
            34 : FCOLOR:=cl_Blue;
            |

            // ESC [ 35 m = Vordergrundfarbe - 35 Karmesinrot (Purpur, lila)
            35 : FCOLOR:=cl_Purple;
            |

           // ESC [ 36 m = Vordergrundfarbe - 36 Cyanblau
            36 : FCOLOR:=cl_Aqua;
            |

            // ESC [ 37 m = Vordergrundfarbe - 37 Weiß
            37 : FCOLOR:=cl_White;
            |





            // *** Hintergrundfarben ***

            // ESC [ 40 m = Hintergrundfarbe - 40 Schwarz
            40 : BCOLOR:=cl_Black;
            |

            // ESC [ 41 m = Hintergrundfarbe - 41 Rot
            41 : BCOLOR:=cl_Red;
            |

            // ESC [ 42 m = Hintergrundfarbe - 42 Grün
            42 : BCOLOR:=cl_Green;
            |

            // ESC [ 43 m = Hintergrundfarbe - 43 Gelb
            43 : BCOLOR:=cl_Yellow;
            |

            // ESC [ 44 m = Hintergrundfarbe - 44 Blau
            44 : BCOLOR:=cl_Blue;
            |

            // ESC [ 45 m = Hintergrundfarbe - 45 Karmesinrot (Purpur, lila)
            45 : BCOLOR:=cl_Purple;
            |

           // ESC [ 46 m = Hintergrundfarbe - 46 Cyanblau
            46 : BCOLOR:=cl_Aqua;
            |

            // ESC [ 47 m = Hintergrundfarbe - 47 Weiß
            47 : BCOLOR:=cl_White;
            |







          else
            Fehler_ESC_CSI_Par_mZ; 
          endcase;
          CSI_Parameter1:=0;
          TermMode:=Normal_TM;
    |



  else

    Fehler_ESC_CSI_Par_mZ;

  endcase; { case Zeichen of }

end IBM_CSI_Par_Terminal_Mode;








// IBM_CSI_TM_Par_Zeile
procedure IBM_CSI_Par_Zeile_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_Zeile;
    |

    $3B : // ";" 
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m

          if CSI_Parameter2=5 then

            if CSI_Parameter1=48 then
              TermMode:=IBM_CSI_TM_Par_Xterm;
              CSI_Parameter2:=0;
            endif; 

            if CSI_Parameter1=38 then
              TermMode:=IBM_CSI_TM_Par_Xterm;
              CSI_Parameter2:=0;
            endif; 

          else
            Fehler_ESC_CSI_Par_Zeile_mZ;
          endif;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;
    |
 
  else
 
    Fehler_ESC_CSI_Par_Zeile_mZ;
 
  endcase; { case Zeichen of }


end IBM_CSI_Par_Zeile_Terminal_Mode;





procedure IBM_CSI_Par_Xterm_Terminal_Mode;
begin


  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_Xterm;

    |

    $6D : // "m"
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m


          if CSI_Parameter1=48 then
            BCOLOR:=Low(CSI_Parameter2);
            CSI_Parameter1:=0;
            CSI_Parameter2:=0;
            TermMode:=Normal_TM;
          endif; 

          if CSI_Parameter1=38 then
            BCOLOR:=Low(CSI_Parameter2);
            CSI_Parameter1:=0;
            CSI_Parameter2:=0;
            TermMode:=Normal_TM;
          endif; 

    |

  else

    Fehler_ESC_CSI_Par_Zeile_mZ;

  endcase; { case Zeichen of }



end IBM_CSI_Par_Xterm_Terminal_Mode;





procedure IBM_GRAPHIC_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_GRAPHIC_TM;

    |

    $3B : // ";"
          TermMode:=IBM_GRAPHIC_P2_TM;

    |

    $43 : // "C" -- GrafikSetColor = ESC G Pn1 C
          PIXCOLOR:=Low(CSI_Parameter1);
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |

  else

    Fehler_ESC;

  endcase; { case Zeichen of }


end IBM_GRAPHIC_Terminal_Mode;





procedure IBM_GRAPHIC_P2_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_GRAPHIC_P2_TM;

    |

    $47 : // "G" -- GrafikSetCursor = ESC G Pn1 ; Pn2 G
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |

    $50 : // "P" -- GrafikDrawPoint = ESC G Pn1 ; Pn2 P
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          GrafikDrawPoint;
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |

    $4C : // "L" -- GrafikDrawLine = ESC G Pn1 ; Pn2 L
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          GrafikDrawLine;
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |

    $52 : // "R" -- GrafikDrawRectangle = ESC G Pn1 ; Pn2 R
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          GrafikDrawRectangle;
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |


    $46 : // "F" -- GrafikDrawFullRectangle = ESC G Pn1 ; Pn2 F
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          GrafikDrawFullRectangle;
          CSI_Parameter1:=0;
          CSI_Parameter2:=0;
          TermMode:=Normal_TM;

    |






  else

    Fehler_ESC;

  endcase; { case Zeichen of }


end IBM_GRAPHIC_P2_Terminal_Mode;








procedure CONOUT;
begin

  if Kursor_Ein then
    Schalte_Kursor_Aus;
    Kursor_Ein:=false;
  endif;
  Kursor_Schleife:=0;
  KurArr_Aktuell:=false;
 
  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par       : IBM_CSI_Par_Terminal_Mode;
    |

    IBM_CSI_TM_Par_Zeile : IBM_CSI_Par_Zeile_Terminal_Mode;
    |

    IBM_CSI_TM_Par_Xterm : IBM_CSI_Par_Xterm_Terminal_Mode;
    |

    IBM_GRAPHIC_TM       : IBM_GRAPHIC_Terminal_Mode;
    |

    IBM_GRAPHIC_P2_TM    : IBM_GRAPHIC_P2_Terminal_Mode;
    |

  endcase;

end CONOUT;











// ******************************
// *** serielle Schnittstelle ***
// ******************************


procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_GN); // gruen ein
  endwhile;

  ClearBit(LED_GN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen; 



procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt 
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
    CONOUT;
    sende_Zeichen(XON);
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;







{--------------------------------------------------------------}
{ Main Program }
{$IDATA}







begin

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  Kursor_Ein:=false;
  KurArr_Aktuell:=false;
  Kursor_Schleife:=0;


  TermMode:=Normal_TM;
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;


  InitPorts;
  INIT_SER_PORT;

  ClearBit(LED_GN);
  ClearBit(VS1_GS2);

  // Grundeinstellung
  DDRA:=  %00000000;
  SetBit(WE);
  SetBit(DIR);
  SetBit(OE);

  PORTA:=%00000000;
  PORTB:=%00000000;
  PORTC:=%00000000;
  ClearBit(A16);

  Reset_Form;

//  init_Bild;

  sende_Zeichen(XON);

  loop

    RX_Puffer_abfragen;

    Inc(Kursor_Schleife);

    if Kursor_Schleife=63000 then

      Kursor_Schleife:=0;

      if Kursor_Ein then
        Kursor_Ein:=false;
        Schalte_Kursor_Aus;
      else
        Kursor_Ein:=true;
        Schalte_Kursor_Ein;
      endif; { if Kursor_Ein then }

    endif; { if Kursor_Schleife=63000 then }

  endloop;


end GCON.


