; Assemblerquelltext des DPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: GCON.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        BAUDRATE  =  0x62A5 ; WORD
.equ        UBRR_VAL  =  0x0031 ; WORD
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        ZEICHENBREITE  =  0x0006 ; WORD
.equ        ZEICHENHOEHE  =  0x000A ; WORD
.equ        X_ANF  =  0x000C ; WORD
.equ        Y_ANF  =  0x0001 ; WORD
.equ        MAX_SPALTEN  =  0x004F ; WORD
.equ        MAX_ZEILEN  =  0x0017 ; WORD
.equ        CL_WHITE  =  0xFF ; BYTE
.equ        CL_BLACK  =  0x00 ; BYTE
.equ        CL_RED  =  0x43 ; BYTE
.equ        CL_GREEN  =  0x4C ; BYTE
.equ        CL_BLUE  =  0xB0 ; BYTE
.equ        CL_YELLOW  =  0x4F ; BYTE
.equ        CL_PURPLE  =  0x73 ; BYTE
.equ        CL_AQUA  =  0x7C ; BYTE
.equ        CL_GRAY  =  0x6A ; BYTE
.equ        NORMAL_TM  =  0x00 ; BYTE
.equ        IBM_ESC_TM  =  0x01 ; BYTE
.equ        IBM_CSI_TM  =  0x02 ; BYTE
.equ        IBM_CSI_TM_PAR  =  0x03 ; BYTE
.equ        IBM_CSI_TM_PAR_ZEILE  =  0x04 ; BYTE
.equ        IBM_CSI_TM_PAR_XTERM  =  0x05 ; BYTE
.equ        IBM_GRAPHIC_TM  =  0x06 ; BYTE
.equ        IBM_GRAPHIC_P2_TM  =  0x07 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
FCOLOR:   ; Byte
.byte     1
BCOLOR:   ; Byte
.byte     1
PIXCOLOR:   ; Byte
.byte     1
ZEICHEN:   ; Byte
.byte     1
X_KUR_POS:   ; Word
.byte     2
Y_KUR_POS:   ; Word
.byte     2
X_PIX_POS:   ; Word
.byte     2
Y_PIX_POS:   ; Word
.byte     2
X_END_POS:   ; Word
.byte     2
Y_END_POS:   ; Word
.byte     2
KURSOR_SCHLEIFE:   ; Word
.byte     2
KURSOR_EIN:   ; Boolean
.byte     1
KURARR_AKTUELL:   ; Boolean
.byte     1
TERMMODE:   ; Byte
.byte     1
CSI_PARAMETER1:   ; Word
.byte     2
CSI_PARAMETER2:   ; Word
.byte     2
DELTA_X:   ; Word
.byte     2
DELTA_Y:   ; Word
.byte     2
 
KURSOR_ARRAY:
 .byte     48
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.org 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFE)
        LDI        R16, 0xFE
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x58)
        LDI        R16, 0x58
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, LOW(0x0031)
        LDI        R17, HIGH(0x0031)
 
; Zuweisung Ziel /  VAR (UBRR0)
        STS        UBRR0, R16
        STS        UBRR0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R2
        MOV        R17, R3
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_01:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_02
        RJMP       M_FTD_03
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_02:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x02D0)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_04:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_05
        RJMP       M_FTD_06
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_05:
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_04
 
; FOR TO DO - Ende
M_FTD_06:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_01
 
; FOR TO DO - Ende
M_FTD_03:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; FUNCTION - Anfang (RANDOM)
RANDOM:
 
; RETURN Byte-Variable - FUNCTION (RANDOM)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (RANDOM)
        MOV        R16, R2
 
; FUNCTION - Ende (RANDOM)
        RET
 
; PROCEDURE - Anfang (CLEAR_RAM)
CLEAR_RAM:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00FF)
        LDI        R16, LOW(0x00FF)
        LDI        R17, HIGH(0x00FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_07:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_08
        RJMP       M_FTD_09
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_08:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x01FF)
        LDI        R16, LOW(0x01FF)
        LDI        R17, HIGH(0x01FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_010:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_011
        RJMP       M_FTD_012
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_011:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_010
 
; FOR TO DO - Ende
M_FTD_012:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R6
        MOV        R17, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_016
        CLR        R16
        RJMP       M_VERGL_017
M_VERGL_016:
        SER        R16
M_VERGL_017:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_013
        RJMP       M_IF_014
M_IF_013:
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN - Ende
M_IF_014:
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_07
 
; FOR TO DO - Ende
M_FTD_09:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (CLEAR_RAM)
        RET
 
; PROCEDURE - Anfang (SCREENROLL)
SCREENROLL:
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ASM
; Vereinbarungsteil
; -----------------
.EQU  C_A16 = 2
.EQU  C_WE  = 3
.EQU  C_OE  = 4
.EQU  C_DIR = 6

; Voreinstellungen
; ----------------

      ; Loeschen von A16
      CBI    PORTD, C_A16



      ; R19=0 (Eingang)
      CLR    R19

      ; R20=FF (Ausgang)
      SER    R20
 

      CALL   ScreenRoll1_ANF

      CALL   ScreenRoll2_ANF

      ; Setzen von A16
      SBI    PORTD, C_A16

      CALL   ScreenRoll1_ANF

      RJMP   ScreenRoll_END

; -----------------------------

ScreenRoll1_ANF:
      
      ; R17 = Y_POS_Ziel
      CLR    R17 

      ; R18 = Y_POS_Quelle
      LDI    R18, 20 

ScreenRoll1_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll1_X:

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE

     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R18, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_Y

    ; Ruecksprung
    RET




ScreenRoll2_ANF:
      
      ; R17 = Y_POS_Ziel
      LDI    R17, 236 

      ; R18 = Y_POS_Quelle
      CLR    R18 


ScreenRoll2_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll2_X:

      ; Setzen von A16
      SBI    PORTD, C_A16

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE


      ; Loeschen von A16
      CBI    PORTD, C_A16


     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R17, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_Y

    ; Ruecksprung
    RET




ScreenRoll_END:



 
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SCREENROLL)
        RET
 
; PROCEDURE - Anfang (TOGGLE_RAMPAGE)
TOGGLE_RAMPAGE:
 
; IF THEN - Ausdruck /; BitHigh(VS1_GS2)
        IN         R16, PORTD
        BST        R16, 5
        BRTS       M_VERGL_021
        CLR        R16
        RJMP       M_VERGL_022
M_VERGL_021:
        SER        R16
M_VERGL_022:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_018
        RJMP       M_IF_019
M_IF_018:
 
; ClearBit(VS1_GS2)
        CBI        PORTD, 5
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_020
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_019:
 
; SetBit(VS1_GS2)
        SBI        PORTD, 5
 
; IF_THEN_ELSE - Ende
M_IF_020:
 
; PROCEDURE - Ende (TOGGLE_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (RESET_FORM)
RESET_FORM:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (Y_ANF)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; PROCEDURE - Ende (RESET_FORM)
        RET
 
; PROCEDURE - Anfang (WRITE_BILD)
WRITE_BILD:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_POINTER)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x3F)
        LDI        R16, 0x3F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_023:
 
; FOR TO DO - Byte-Vergleichsteil
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_024
        RJMP       M_FTD_025
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_024:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R3, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x3F)
        LDI        R16, 0x3F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R3
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_026:
 
; FOR TO DO - Byte-Vergleichsteil
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_027
        RJMP       M_FTD_028
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_027:
 
; CONST ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CONST ARRAY (BILD)
        LDI        ZL, LOW(2*BILD)
        LDI        ZH, HIGH(2*BILD)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R5
        MOV        R25, R6
        ADIW       R25:R24, 1
        MOV        R5, R24
        MOV        R6, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R5
        MOV        R25, R6
        ADIW       R25:R24, 1
        MOV        R5, R24
        MOV        R6, R25
 
; INC(B_POINTER) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Byte-INC-Zaehler
        MOV        R17, R3
        INC        R17
        MOV        R3, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_026
 
; FOR TO DO - Ende
M_FTD_028:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0180)
        LDI        R18, LOW(0x0180)
        LDI        R19, HIGH(0x0180)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; FOR TO DO - Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_023
 
; FOR TO DO - Ende
M_FTD_025:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (WRITE_BILD)
        RET
 
; PROCEDURE - Anfang (INIT_BILD)
INIT_BILD:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (Y_ANF)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (WRITE_BILD)
        CALL       WRITE_BILD
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (Y_ANF)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (WRITE_BILD)
        CALL       WRITE_BILD
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (Y_ANF)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (INIT_BILD)
        RET
 
; PROCEDURE - Anfang (SET_POINT)
SET_POINT:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_032
        CLR        R16
        RJMP       M_VERGL_033
M_VERGL_032:
        SER        R16
M_VERGL_033:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_029
        RJMP       M_IF_030
M_IF_029:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_031
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_030:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_031:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SET_POINT)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWPOINT)
GRAFIKDRAWPOINT:
 
; Aufruf PROCEDURE (SET_POINT)
        CALL       SET_POINT
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (SET_POINT)
        CALL       SET_POINT
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; PROCEDURE - Ende (GRAFIKDRAWPOINT)
        RET
 
; PROCEDURE - Anfang (SET_POINT_POS)
SET_POINT_POS:
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_037
        CLR        R16
        RJMP       M_VERGL_038
M_VERGL_037:
        SER        R16
M_VERGL_038:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_034
        RJMP       M_IF_035
M_IF_034:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_POINT_POS)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_036
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_035:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_POINT_POS)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R6, R16
        MOV        R7, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_036:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SET_POINT_POS)
        RET
 
; PROCEDURE - Anfang (LINE_TO)
LINE_TO:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (X_END_POS)
        LDS        R18, X_END_POS
        LDS        R19, X_END_POS+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_042
        CLR        R16
        RJMP       M_VERGL_043
M_VERGL_042:
        SER        R16
M_VERGL_043:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_039
        RJMP       M_IF_040
M_IF_039:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_X)
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_ANF)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_END)
        MOV        R6, R16
        MOV        R7, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_041
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_040:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_END_POS)
        LDS        R18, X_END_POS
        LDS        R19, X_END_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_X)
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_ANF)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_END)
        MOV        R6, R16
        MOV        R7, R17
 
; IF_THEN_ELSE - Ende
M_IF_041:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (Y_END_POS)
        LDS        R18, Y_END_POS
        LDS        R19, Y_END_POS+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_047
        CLR        R16
        RJMP       M_VERGL_048
M_VERGL_047:
        SER        R16
M_VERGL_048:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_044
        RJMP       M_IF_045
M_IF_044:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_PIX_POS)
        LDS        R18, Y_PIX_POS
        LDS        R19, Y_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_Y)
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_ANF)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_END)
        MOV        R12, R16
        MOV        R13, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_046
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_045:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_END_POS)
        LDS        R18, Y_END_POS
        LDS        R19, Y_END_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_Y)
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_ANF)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_END)
        MOV        R12, R16
        MOV        R13, R17
 
; IF_THEN_ELSE - Ende
M_IF_046:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_052
        CLR        R16
        RJMP       M_VERGL_053
M_VERGL_052:
        SER        R16
M_VERGL_053:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_049
        RJMP       M_IF_050
M_IF_049:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (XP_ANF)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (XP_END)
        MOV        R16, R6
        MOV        R17, R7
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_059:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_060
        RJMP       M_FTD_061
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_060:
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
        PUSH       R12
        PUSH       R13
 
; Word-Parameter(2) fuer PROCEDURE (SET_POINT_POS)
        LDS        R4, Y_PIX_POS
        LDS        R5, Y_PIX_POS+1
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R13
        POP        R12
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_059
 
; FOR TO DO - Ende
M_FTD_061:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_065
        CLR        R16
        RJMP       M_VERGL_066
M_VERGL_065:
        SER        R16
M_VERGL_066:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_062
        RJMP       M_IF_063
M_IF_062:
 
; SHR(DELTA_X) - Word
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
        LSR        R17
        ROR        R16
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; SHR(DELTA_Y) - Word
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
        LSR        R17
        ROR        R16
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; IF_THEN - Ende
M_IF_063:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_070
        CLR        R16
        RJMP       M_VERGL_071
M_VERGL_070:
        SER        R16
M_VERGL_071:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_067
        RJMP       M_IF_068
M_IF_067:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (XP_ANF)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (XP_END)
        MOV        R16, R6
        MOV        R17, R7
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_072:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_073
        RJMP       M_FTD_074
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_073:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_X)
        LDS        R18, DELTA_X
        LDS        R19, DELTA_X+1
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (Y_ANF)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R8
        MOV        R19, R9
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R8, R16
        MOV        R9, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
        PUSH       R12
        PUSH       R13
 
; Parameter (Y1) retten
        MOV        R22, R8
        MOV        R23, R9
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R4, R22
        MOV        R5, R23
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R13
        POP        R12
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_072
 
; FOR TO DO - Ende
M_FTD_074:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_068:
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_051
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_050:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YP_ANF)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R8, R16
        MOV        R9, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (YP_END)
        MOV        R16, R12
        MOV        R17, R13
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R8
        MOV        R19, R9
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_080:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_081
        RJMP       M_FTD_082
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_081:
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
        PUSH       R12
        PUSH       R13
 
; Parameter (Y1) retten
        MOV        R22, R8
        MOV        R23, R9
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R4, R22
        MOV        R5, R23
 
; Word-Parameter(1) fuer PROCEDURE (SET_POINT_POS)
        LDS        R2, X_PIX_POS
        LDS        R3, X_PIX_POS+1
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R13
        POP        R12
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R8
        MOV        R19, R9
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R8, R18
        MOV        R9, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_080
 
; FOR TO DO - Ende
M_FTD_082:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_077
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_076:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_086
        CLR        R16
        RJMP       M_VERGL_087
M_VERGL_086:
        SER        R16
M_VERGL_087:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_083
        RJMP       M_IF_084
M_IF_083:
 
; SHR(DELTA_X) - Word
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
        LSR        R17
        ROR        R16
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; SHR(DELTA_Y) - Word
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
        LSR        R17
        ROR        R16
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; IF_THEN - Ende
M_IF_084:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_091
        CLR        R16
        RJMP       M_VERGL_092
M_VERGL_091:
        SER        R16
M_VERGL_092:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_088
        RJMP       M_IF_089
M_IF_088:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YP_ANF)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R8, R16
        MOV        R9, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (YP_END)
        MOV        R16, R12
        MOV        R17, R13
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R8
        MOV        R19, R9
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_093:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_094
        RJMP       M_FTD_095
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_094:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_X)
        LDS        R18, DELTA_X
        LDS        R19, DELTA_X+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
        PUSH       R12
        PUSH       R13
 
; Parameter (Y1) retten
        MOV        R22, R8
        MOV        R23, R9
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R4, R22
        MOV        R5, R23
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R13
        POP        R12
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R8
        MOV        R19, R9
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R8, R18
        MOV        R9, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_093
 
; FOR TO DO - Ende
M_FTD_095:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_089:
 
; IF_THEN_ELSE - Ende
M_IF_077:
 
; IF_THEN_ELSE - Ende
M_IF_051:
 
; PROCEDURE - Ende (LINE_TO)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWLINE)
GRAFIKDRAWLINE:
 
; Aufruf PROCEDURE (LINE_TO)
        CALL       LINE_TO
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (LINE_TO)
        CALL       LINE_TO
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWLINE)
        RET
 
; PROCEDURE - Anfang (DRAW_REC)
DRAW_REC:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_099
        CLR        R16
        RJMP       M_VERGL_0100
M_VERGL_099:
        SER        R16
M_VERGL_0100:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_096
        RJMP       M_IF_097
M_IF_096:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_098
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_097:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_098:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0101:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0102
        RJMP       M_FTD_0103
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0102:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0101
 
; FOR TO DO - Ende
M_FTD_0103:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; DEC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        SBIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0104:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0105
        RJMP       M_FTD_0106
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0105:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; INC(YR_POS) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R6
        MOV        R17, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0110
        CLR        R16
        RJMP       M_VERGL_0111
M_VERGL_0110:
        SER        R16
M_VERGL_0111:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0107
        RJMP       M_IF_0108
M_IF_0107:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0108:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0104
 
; FOR TO DO - Ende
M_FTD_0106:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0115
        CLR        R16
        RJMP       M_VERGL_0116
M_VERGL_0115:
        SER        R16
M_VERGL_0116:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0112
        RJMP       M_IF_0113
M_IF_0112:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0114
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0113:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0114:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0117:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0118
        RJMP       M_FTD_0119
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0118:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; INC(YR_POS) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R6
        MOV        R17, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0123
        CLR        R16
        RJMP       M_VERGL_0124
M_VERGL_0123:
        SER        R16
M_VERGL_0124:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0120
        RJMP       M_IF_0121
M_IF_0120:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R6, R16
        MOV        R7, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0121:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0117
 
; FOR TO DO - Ende
M_FTD_0119:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0125:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0126
        RJMP       M_FTD_0127
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0126:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0125
 
; FOR TO DO - Ende
M_FTD_0127:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (DRAW_REC)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWRECTANGLE)
GRAFIKDRAWRECTANGLE:
 
; Aufruf PROCEDURE (DRAW_REC)
        CALL       DRAW_REC
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (DRAW_REC)
        CALL       DRAW_REC
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWRECTANGLE)
        RET
 
; PROCEDURE - Anfang (DRAW_FULL_REC)
DRAW_FULL_REC:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0128:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0129
        RJMP       M_FTD_0130
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0129:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R6
        MOV        R17, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0134
        CLR        R16
        RJMP       M_VERGL_0135
M_VERGL_0134:
        SER        R16
M_VERGL_0135:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0131
        RJMP       M_IF_0132
M_IF_0131:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0133
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0132:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0133:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0136:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0137
        RJMP       M_FTD_0138
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0137:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0136
 
; FOR TO DO - Ende
M_FTD_0138:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0128
 
; FOR TO DO - Ende
M_FTD_0130:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (DRAW_FULL_REC)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWFULLRECTANGLE)
GRAFIKDRAWFULLRECTANGLE:
 
; Aufruf PROCEDURE (DRAW_FULL_REC)
        CALL       DRAW_FULL_REC
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (DRAW_FULL_REC)
        CALL       DRAW_FULL_REC
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWFULLRECTANGLE)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR)
WRITE_CHAR:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R2, R16
        MOV        R3, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0142
        CLR        R16
        RJMP       M_VERGL_0143
M_VERGL_0142:
        SER        R16
M_VERGL_0143:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0139
        RJMP       M_IF_0140
M_IF_0139:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0144:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0145
        RJMP       M_FTD_0146
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0145:
 
; CONST ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R9, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0147:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0148
        RJMP       M_FTD_0149
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0148:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R8, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R8
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0153
        CLR        R16
        RJMP       M_VERGL_0154
M_VERGL_0153:
        SER        R16
M_VERGL_0154:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0150
        RJMP       M_IF_0151
M_IF_0150:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0152
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0151:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0152:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R10
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R11
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; INC(ADRESSE) - Word
        MOV        R24, R10
        MOV        R25, R11
        ADIW       R25:R24, 1
        MOV        R10, R24
        MOV        R11, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0147
 
; FOR TO DO - Ende
M_FTD_0149:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0144
 
; FOR TO DO - Ende
M_FTD_0146:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; CONST ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R9, R16
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0155:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0156
        RJMP       M_FTD_0157
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0156:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R8, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R8
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0161
        CLR        R16
        RJMP       M_VERGL_0162
M_VERGL_0161:
        SER        R16
M_VERGL_0162:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0158
        RJMP       M_IF_0159
M_IF_0158:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0160
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0159:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0160:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R10
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R11
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; INC(ADRESSE) - Word
        MOV        R24, R10
        MOV        R25, R11
        ADIW       R25:R24, 1
        MOV        R10, R24
        MOV        R11, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0155
 
; FOR TO DO - Ende
M_FTD_0157:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0141
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0140:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0166
        CLR        R16
        RJMP       M_VERGL_0167
M_VERGL_0166:
        SER        R16
M_VERGL_0167:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0163
        RJMP       M_IF_0164
M_IF_0163:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0165
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0164:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0165:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0168:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0169
        RJMP       M_FTD_0170
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0169:
 
; CONST ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R9, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0171:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0172
        RJMP       M_FTD_0173
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0172:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R8, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R8
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0177
        CLR        R16
        RJMP       M_VERGL_0178
M_VERGL_0177:
        SER        R16
M_VERGL_0178:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0174
        RJMP       M_IF_0175
M_IF_0174:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0176
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0175:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0176:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R10
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R11
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R9
 
; INC(ADRESSE) - Word
        MOV        R24, R10
        MOV        R25, R11
        ADIW       R25:R24, 1
        MOV        R10, R24
        MOV        R11, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0171
 
; FOR TO DO - Ende
M_FTD_0173:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R10
        MOV        R17, R11
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R10, R16
        MOV        R11, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0168
 
; FOR TO DO - Ende
M_FTD_0170:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0141:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (WRITE_CHAR)
        RET
 
; PROCEDURE - Anfang (VRAM_TO_PUFFER)
VRAM_TO_PUFFER:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0182
        CLR        R16
        RJMP       M_VERGL_0183
M_VERGL_0182:
        SER        R16
M_VERGL_0183:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0179
        RJMP       M_IF_0180
M_IF_0179:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KURPOS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0184:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0185
        RJMP       M_FTD_0186
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0185:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0187:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0188
        RJMP       M_FTD_0189
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0188:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0187
 
; FOR TO DO - Ende
M_FTD_0189:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0184
 
; FOR TO DO - Ende
M_FTD_0186:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0190:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0191
        RJMP       M_FTD_0192
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0191:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0190
 
; FOR TO DO - Ende
M_FTD_0192:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0181
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0180:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0196
        CLR        R16
        RJMP       M_VERGL_0197
M_VERGL_0196:
        SER        R16
M_VERGL_0197:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0193
        RJMP       M_IF_0194
M_IF_0193:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0195
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0194:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0195:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KURPOS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0198:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0199
        RJMP       M_FTD_0200
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0199:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0201:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0202
        RJMP       M_FTD_0203
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0202:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0201
 
; FOR TO DO - Ende
M_FTD_0203:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0198
 
; FOR TO DO - Ende
M_FTD_0200:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0181:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; PROCEDURE - Ende (VRAM_TO_PUFFER)
        RET
 
; PROCEDURE - Anfang (PUFFER_TO_VRAM)
PUFFER_TO_VRAM:
 
; IF THEN - Ausdruck / Byte-VAR (KURARR_AKTUELL)
        LDS        R16, KURARR_AKTUELL
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0204
        RJMP       M_IF_0205
M_IF_0204:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0210
        CLR        R16
        RJMP       M_VERGL_0211
M_VERGL_0210:
        SER        R16
M_VERGL_0211:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0207
        RJMP       M_IF_0208
M_IF_0207:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KURPOS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0212:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0213
        RJMP       M_FTD_0214
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0213:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0215:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0216
        RJMP       M_FTD_0217
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0216:
 
; VAR ARRAY - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; Zuweisung VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0215
 
; FOR TO DO - Ende
M_FTD_0217:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0212
 
; FOR TO DO - Ende
M_FTD_0214:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0218:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0219
        RJMP       M_FTD_0220
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0219:
 
; VAR ARRAY - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; Zuweisung VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0218
 
; FOR TO DO - Ende
M_FTD_0220:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0209
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0208:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0224
        CLR        R16
        RJMP       M_VERGL_0225
M_VERGL_0224:
        SER        R16
M_VERGL_0225:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0221
        RJMP       M_IF_0222
M_IF_0221:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0223
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0222:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0223:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KURPOS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0226:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0227
        RJMP       M_FTD_0228
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0227:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0229:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0230
        RJMP       M_FTD_0231
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0230:
 
; VAR ARRAY - Ausdruck / lokale, dynamische Variable VAR (KURPOS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; Zuweisung VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; INC(KURPOS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0229
 
; FOR TO DO - Ende
M_FTD_0231:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0226
 
; FOR TO DO - Ende
M_FTD_0228:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0209:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN - Ende
M_IF_0205:
 
; PROCEDURE - Ende (PUFFER_TO_VRAM)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_EIN)
SCHALTE_KURSOR_EIN:
 
; Aufruf PROCEDURE (VRAM_TO_PUFFER)
        CALL       VRAM_TO_PUFFER
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5F)
        LDI        R16, 0x5F
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; PROCEDURE - Ende (SCHALTE_KURSOR_EIN)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_AUS)
SCHALTE_KURSOR_AUS:
 
; Aufruf PROCEDURE (PUFFER_TO_VRAM)
        CALL       PUFFER_TO_VRAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (PUFFER_TO_VRAM)
        CALL       PUFFER_TO_VRAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; PROCEDURE - Ende (SCHALTE_KURSOR_AUS)
        RET
 
; PROCEDURE - Anfang (DELETE_EOL)
DELETE_EOL:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0232:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0233
        RJMP       M_FTD_0234
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0233:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0232
 
; FOR TO DO - Ende
M_FTD_0234:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0235:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0236
        RJMP       M_FTD_0237
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0236:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0235
 
; FOR TO DO - Ende
M_FTD_0237:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_EOL)
        RET
 
; PROCEDURE - Anfang (DELETE_BOL)
DELETE_BOL:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0238:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0239
        RJMP       M_FTD_0240
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0239:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0238
 
; FOR TO DO - Ende
M_FTD_0240:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0241:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0242
        RJMP       M_FTD_0243
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0242:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0241
 
; FOR TO DO - Ende
M_FTD_0243:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_BOL)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE)
DELETE_LINE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0244:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0245
        RJMP       M_FTD_0246
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0245:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0244
 
; FOR TO DO - Ende
M_FTD_0246:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0247:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0248
        RJMP       M_FTD_0249
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0248:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0247
 
; FOR TO DO - Ende
M_FTD_0249:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_LINE)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE_SCR_ROLL)
DELETE_LINE_SCR_ROLL:
 
; PROCEDURE - Ende (DELETE_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (INSERT_LINE_SCR_ROLL)
INSERT_LINE_SCR_ROLL:
 
; PROCEDURE - Ende (INSERT_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (SET_CURSOR_POSITION)
SET_CURSOR_POSITION:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SPALTE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x004F)
        LDI        R18, LOW(0x004F)
        LDI        R19, HIGH(0x004F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0253
        CLR        R16
        RJMP       M_VERGL_0254
M_VERGL_0253:
        SER        R16
M_VERGL_0254:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0250
        RJMP       M_IF_0251
M_IF_0250:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0251:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (X_ANF)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (ZEILE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0017)
        LDI        R18, LOW(0x0017)
        LDI        R19, HIGH(0x0017)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0258
        CLR        R16
        RJMP       M_VERGL_0259
M_VERGL_0258:
        SER        R16
M_VERGL_0259:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0255
        RJMP       M_IF_0256
M_IF_0255:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0017)
        LDI        R16, LOW(0x0017)
        LDI        R17, HIGH(0x0017)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0256:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (Y_ANF)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (SET_CURSOR_POSITION)
        RET
 
; PROCEDURE - Anfang (CURSOR_RIGHT)
CURSOR_RIGHT:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (MAX_SPALTEN)
        LDI        R18, LOW(0x004F)
        LDI        R19, HIGH(0x004F)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0263
        CLR        R16
        RJMP       M_VERGL_0264
M_VERGL_0263:
        SER        R16
M_VERGL_0264:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0260
        RJMP       M_IF_0261
M_IF_0260:
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ZEICHENBREITE)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0261:
 
; PROCEDURE - Ende (CURSOR_RIGHT)
        RET
 
; PROCEDURE - Anfang (WRITELN_CHAR_RP)
WRITELN_CHAR_RP:
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (CURSOR_RIGHT)
        CALL       CURSOR_RIGHT
 
; PROCEDURE - Ende (WRITELN_CHAR_RP)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC)
FEHLER_ESC:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x45)
        LDI        R16, 0x45
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x53)
        LDI        R16, 0x53
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x43)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; PROCEDURE - Ende (FEHLER_ESC)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_MZ)
FEHLER_ESC_MZ:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (FEHLER_ESC)
        CALL       FEHLER_ESC
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_MZ)
        POP        R2
 
; PROCEDURE - Ende (FEHLER_ESC_MZ)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI)
FEHLER_ESC_CSI:
 
; Aufruf PROCEDURE (FEHLER_ESC)
        CALL       FEHLER_ESC
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5B)
        LDI        R16, 0x5B
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; PROCEDURE - Ende (FEHLER_ESC_CSI)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI_MZ)
FEHLER_ESC_CSI_MZ:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI)
        CALL       FEHLER_ESC_CSI
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; PROCEDURE - Ende (FEHLER_ESC_CSI_MZ)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI_PAR)
FEHLER_ESC_CSI_PAR:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI)
        CALL       FEHLER_ESC_CSI
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; PROCEDURE - Ende (FEHLER_ESC_CSI_PAR)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI_PAR_MZ)
FEHLER_ESC_CSI_PAR_MZ:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR)
        CALL       FEHLER_ESC_CSI_PAR
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; PROCEDURE - Ende (FEHLER_ESC_CSI_PAR_MZ)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI_PAR_ZEILE)
FEHLER_ESC_CSI_PAR_ZEILE:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR)
        CALL       FEHLER_ESC_CSI_PAR
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x3B)
        LDI        R16, 0x3B
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; PROCEDURE - Ende (FEHLER_ESC_CSI_PAR_ZEILE)
        RET
 
; PROCEDURE - Anfang (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
FEHLER_ESC_CSI_PAR_ZEILE_MZ:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE)
        CALL       FEHLER_ESC_CSI_PAR_ZEILE
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (LOK_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_CHAR_RP)
        CALL       WRITELN_CHAR_RP
 
; Retten der Parameter-Register fuer PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        POP        R2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; PROCEDURE - Ende (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        RET
 
; PROCEDURE - Anfang (NORMAL_TERMINAL_MODE)
NORMAL_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($0A)
        CPI        R16, 0x0A
        BREQ       M_CASE_0267
        RJMP       M_CASE_0266
M_CASE_0267:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0017)
        LDI        R18, LOW(0x0017)
        LDI        R19, HIGH(0x0017)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0271
        CLR        R16
        RJMP       M_VERGL_0272
M_VERGL_0271:
        SER        R16
M_VERGL_0272:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0268
        RJMP       M_IF_0269
M_IF_0268:
 
; INC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        ADIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0270
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0269:
 
; Aufruf PROCEDURE (SCREENROLL)
        CALL       SCREENROLL
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (SCREENROLL)
        CALL       SCREENROLL
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; IF_THEN_ELSE - Ende
M_IF_0270:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0266:
 
; CASE OF - vergleiche Einzel-Element ($0C)
        CPI        R16, 0x0C
        BREQ       M_CASE_0274
        RJMP       M_CASE_0273
M_CASE_0274:
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0273:
 
; CASE OF - vergleiche Einzel-Element ($0D)
        CPI        R16, 0x0D
        BREQ       M_CASE_0276
        RJMP       M_CASE_0275
M_CASE_0276:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (X_ANF)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0275:
 
; CASE OF - vergleiche Einzel-Element ($1B)
        CPI        R16, 0x1B
        BREQ       M_CASE_0278
        RJMP       M_CASE_0277
M_CASE_0278:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_ESC_TM)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
 
; CASE OF ELSE
M_CASE_0277:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator >=
        CP         R16, R18
        BRCC       M_VERGL_0282
        CLR        R16
        RJMP       M_VERGL_0283
M_VERGL_0282:
        SER        R16
M_VERGL_0283:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0279
        RJMP       M_IF_0280
M_IF_0279:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator <=
        CP         R18, R16
        BRCC       M_VERGL_0287
        CLR        R16
        RJMP       M_VERGL_0288
M_VERGL_0287:
        SER        R16
M_VERGL_0288:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0284
        RJMP       M_IF_0285
M_IF_0284:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0050)
        LDI        R18, LOW(0x0050)
        LDI        R19, HIGH(0x0050)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0292
        CLR        R16
        RJMP       M_VERGL_0293
M_VERGL_0292:
        SER        R16
M_VERGL_0293:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0289
        RJMP       M_IF_0290
M_IF_0289:
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (TOGGLE_RAMPAGE)
        CALL       TOGGLE_RAMPAGE
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0006)
        LDI        R18, LOW(0x0006)
        LDI        R19, HIGH(0x0006)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Aufruf PROCEDURE (VRAM_TO_PUFFER)
        CALL       VRAM_TO_PUFFER
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; IF_THEN - Ende
M_IF_0290:
 
; IF_THEN - Ende
M_IF_0285:
 
; IF_THEN - Ende
M_IF_0280:
 
; ENDCASE;
M_CASE_0265:
 
; PROCEDURE - Ende (NORMAL_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_ESC_TERMINAL_MODE)
IBM_ESC_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($5B)
        CPI        R16, 0x5B
        BREQ       M_CASE_0296
        RJMP       M_CASE_0295
M_CASE_0296:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0294
M_CASE_0295:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0298
        RJMP       M_CASE_0297
M_CASE_0298:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAPHIC_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0294
 
; CASE OF ELSE
M_CASE_0297:
 
; Aufruf PROCEDURE (FEHLER_ESC_MZ)
        CALL       FEHLER_ESC_MZ
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; ENDCASE;
M_CASE_0294:
 
; PROCEDURE - Ende (IBM_ESC_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_TERMINAL_MODE)
IBM_CSI_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0302
        RJMP       M_CASE_0300
M_CASE_0302:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0301
        RJMP       M_CASE_0300
M_CASE_0301:
 
; Zuweisung Quelle - Ausdruck erster Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
M_CASE_0300:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0304
        RJMP       M_CASE_0303
M_CASE_0304:
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
M_CASE_0303:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0306
        RJMP       M_CASE_0305
M_CASE_0306:
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
 
; CASE OF ELSE
M_CASE_0305:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_MZ)
        CALL       FEHLER_ESC_CSI_MZ
 
; ENDCASE;
M_CASE_0299:
 
; PROCEDURE - Ende (IBM_CSI_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_TERMINAL_MODE)
IBM_CSI_PAR_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0310
        RJMP       M_CASE_0308
M_CASE_0310:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0309
        RJMP       M_CASE_0308
M_CASE_0309:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0308:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0312
        RJMP       M_CASE_0311
M_CASE_0312:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_ZEILE)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0311:
 
; CASE OF - vergleiche Einzel-Element ($4A)
        CPI        R16, 0x4A
        BREQ       M_CASE_0314
        RJMP       M_CASE_0313
M_CASE_0314:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0317
        RJMP       M_CASE_0316
M_CASE_0317:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0315
 
; CASE OF ELSE
M_CASE_0316:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        CALL       FEHLER_ESC_CSI_PAR_MZ
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; ENDCASE;
M_CASE_0315:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0313:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0319
        RJMP       M_CASE_0318
M_CASE_0319:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0322
        RJMP       M_CASE_0321
M_CASE_0322:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0321:
 
; CASE OF - vergleiche Einzel-Element (1)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0324
        RJMP       M_CASE_0323
M_CASE_0324:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DELETE_BOL)
        CALL       DELETE_BOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0323:
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0326
        RJMP       M_CASE_0325
M_CASE_0326:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
 
; CASE OF ELSE
M_CASE_0325:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        CALL       FEHLER_ESC_CSI_PAR_MZ
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; ENDCASE;
M_CASE_0320:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0318:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0328
        RJMP       M_CASE_0327
M_CASE_0328:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0329:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0330
        RJMP       M_FTD_0331
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0330:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (INSERT_LINE_SCR_ROLL)
        CALL       INSERT_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0329
 
; FOR TO DO - Ende
M_FTD_0331:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0327:
 
; CASE OF - vergleiche Einzel-Element ($4D)
        CPI        R16, 0x4D
        BREQ       M_CASE_0333
        RJMP       M_CASE_0332
M_CASE_0333:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0334:
 
; FOR TO DO - Word-Vergleichsteil
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0335
        RJMP       M_FTD_0336
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0335:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DELETE_LINE_SCR_ROLL)
        CALL       DELETE_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; FOR TO DO - Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0334
 
; FOR TO DO - Ende
M_FTD_0336:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
M_CASE_0332:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0338
        RJMP       M_CASE_0337
M_CASE_0338:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0341
        RJMP       M_CASE_0340
M_CASE_0341:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GRAY)
        LDI        R16, 0x6A
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0340:
 
; CASE OF - vergleiche Einzel-Element (4)
        LDI        R18, LOW(0x0004)
        LDI        R19, HIGH(0x0004)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0343
        RJMP       M_CASE_0342
M_CASE_0343:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0342:
 
; CASE OF - vergleiche Einzel-Element (5)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0345
        RJMP       M_CASE_0344
M_CASE_0345:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0344:
 
; CASE OF - vergleiche Einzel-Element (7)
        LDI        R18, LOW(0x0007)
        LDI        R19, HIGH(0x0007)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0347
        RJMP       M_CASE_0346
M_CASE_0347:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0346:
 
; CASE OF - vergleiche Einzel-Element (30)
        LDI        R18, LOW(0x001E)
        LDI        R19, HIGH(0x001E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0349
        RJMP       M_CASE_0348
M_CASE_0349:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0348:
 
; CASE OF - vergleiche Einzel-Element (31)
        LDI        R18, LOW(0x001F)
        LDI        R19, HIGH(0x001F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0351
        RJMP       M_CASE_0350
M_CASE_0351:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0350:
 
; CASE OF - vergleiche Einzel-Element (32)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0353
        RJMP       M_CASE_0352
M_CASE_0353:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0352:
 
; CASE OF - vergleiche Einzel-Element (33)
        LDI        R18, LOW(0x0021)
        LDI        R19, HIGH(0x0021)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0355
        RJMP       M_CASE_0354
M_CASE_0355:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0354:
 
; CASE OF - vergleiche Einzel-Element (34)
        LDI        R18, LOW(0x0022)
        LDI        R19, HIGH(0x0022)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0357
        RJMP       M_CASE_0356
M_CASE_0357:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0356:
 
; CASE OF - vergleiche Einzel-Element (35)
        LDI        R18, LOW(0x0023)
        LDI        R19, HIGH(0x0023)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0359
        RJMP       M_CASE_0358
M_CASE_0359:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0358:
 
; CASE OF - vergleiche Einzel-Element (36)
        LDI        R18, LOW(0x0024)
        LDI        R19, HIGH(0x0024)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0361
        RJMP       M_CASE_0360
M_CASE_0361:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0360:
 
; CASE OF - vergleiche Einzel-Element (37)
        LDI        R18, LOW(0x0025)
        LDI        R19, HIGH(0x0025)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0363
        RJMP       M_CASE_0362
M_CASE_0363:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0362:
 
; CASE OF - vergleiche Einzel-Element (40)
        LDI        R18, LOW(0x0028)
        LDI        R19, HIGH(0x0028)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0365
        RJMP       M_CASE_0364
M_CASE_0365:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0364:
 
; CASE OF - vergleiche Einzel-Element (41)
        LDI        R18, LOW(0x0029)
        LDI        R19, HIGH(0x0029)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0367
        RJMP       M_CASE_0366
M_CASE_0367:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0366:
 
; CASE OF - vergleiche Einzel-Element (42)
        LDI        R18, LOW(0x002A)
        LDI        R19, HIGH(0x002A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0369
        RJMP       M_CASE_0368
M_CASE_0369:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0368:
 
; CASE OF - vergleiche Einzel-Element (43)
        LDI        R18, LOW(0x002B)
        LDI        R19, HIGH(0x002B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0371
        RJMP       M_CASE_0370
M_CASE_0371:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0370:
 
; CASE OF - vergleiche Einzel-Element (44)
        LDI        R18, LOW(0x002C)
        LDI        R19, HIGH(0x002C)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0373
        RJMP       M_CASE_0372
M_CASE_0373:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0372:
 
; CASE OF - vergleiche Einzel-Element (45)
        LDI        R18, LOW(0x002D)
        LDI        R19, HIGH(0x002D)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0375
        RJMP       M_CASE_0374
M_CASE_0375:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0374:
 
; CASE OF - vergleiche Einzel-Element (46)
        LDI        R18, LOW(0x002E)
        LDI        R19, HIGH(0x002E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0377
        RJMP       M_CASE_0376
M_CASE_0377:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0376:
 
; CASE OF - vergleiche Einzel-Element (47)
        LDI        R18, LOW(0x002F)
        LDI        R19, HIGH(0x002F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0379
        RJMP       M_CASE_0378
M_CASE_0379:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
 
; CASE OF ELSE
M_CASE_0378:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        CALL       FEHLER_ESC_CSI_PAR_MZ
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; ENDCASE;
M_CASE_0339:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0307
 
; CASE OF ELSE
M_CASE_0337:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_MZ)
        CALL       FEHLER_ESC_CSI_PAR_MZ
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        POP        R3
        POP        R2
 
; ENDCASE;
M_CASE_0307:
 
; PROCEDURE - Ende (IBM_CSI_PAR_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_ZEILE_TERMINAL_MODE)
IBM_CSI_PAR_ZEILE_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0383
        RJMP       M_CASE_0381
M_CASE_0383:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0382
        RJMP       M_CASE_0381
M_CASE_0382:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_ZEILE)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0381:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0385
        RJMP       M_CASE_0384
M_CASE_0385:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0389
        CLR        R16
        RJMP       M_VERGL_0390
M_VERGL_0389:
        SER        R16
M_VERGL_0390:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0386
        RJMP       M_IF_0387
M_IF_0386:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0394
        CLR        R16
        RJMP       M_VERGL_0395
M_VERGL_0394:
        SER        R16
M_VERGL_0395:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0391
        RJMP       M_IF_0392
M_IF_0391:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_XTERM)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; IF_THEN - Ende
M_IF_0392:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0026)
        LDI        R18, LOW(0x0026)
        LDI        R19, HIGH(0x0026)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0399
        CLR        R16
        RJMP       M_VERGL_0400
M_VERGL_0399:
        SER        R16
M_VERGL_0400:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0396
        RJMP       M_IF_0397
M_IF_0396:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_XTERM)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; IF_THEN - Ende
M_IF_0397:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0388
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0387:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        CALL       FEHLER_ESC_CSI_PAR_ZEILE_MZ
 
; IF_THEN_ELSE - Ende
M_IF_0388:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0384:
 
; CASE OF - vergleiche Einzel-Element ($48)
        CPI        R16, 0x48
        BREQ       M_CASE_0402
        RJMP       M_CASE_0401
M_CASE_0402:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER1
        LDS        R3, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R4, CSI_PARAMETER2
        LDS        R5, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0401:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0404
        RJMP       M_CASE_0403
M_CASE_0404:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER1
        LDS        R3, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R4, CSI_PARAMETER2
        LDS        R5, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
 
; CASE OF ELSE
M_CASE_0403:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        CALL       FEHLER_ESC_CSI_PAR_ZEILE_MZ
 
; ENDCASE;
M_CASE_0380:
 
; PROCEDURE - Ende (IBM_CSI_PAR_ZEILE_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_XTERM_TERMINAL_MODE)
IBM_CSI_PAR_XTERM_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0408
        RJMP       M_CASE_0406
M_CASE_0408:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0407
        RJMP       M_CASE_0406
M_CASE_0407:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_XTERM)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0405
M_CASE_0406:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0410
        RJMP       M_CASE_0409
M_CASE_0410:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0414
        CLR        R16
        RJMP       M_VERGL_0415
M_VERGL_0414:
        SER        R16
M_VERGL_0415:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0411
        RJMP       M_IF_0412
M_IF_0411:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; IF_THEN - Ende
M_IF_0412:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0026)
        LDI        R18, LOW(0x0026)
        LDI        R19, HIGH(0x0026)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0419
        CLR        R16
        RJMP       M_VERGL_0420
M_VERGL_0419:
        SER        R16
M_VERGL_0420:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0416
        RJMP       M_IF_0417
M_IF_0416:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; IF_THEN - Ende
M_IF_0417:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0405
 
; CASE OF ELSE
M_CASE_0409:
 
; Aufruf PROCEDURE (FEHLER_ESC_CSI_PAR_ZEILE_MZ)
        CALL       FEHLER_ESC_CSI_PAR_ZEILE_MZ
 
; ENDCASE;
M_CASE_0405:
 
; PROCEDURE - Ende (IBM_CSI_PAR_XTERM_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAPHIC_TERMINAL_MODE)
IBM_GRAPHIC_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0424
        RJMP       M_CASE_0422
M_CASE_0424:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0423
        RJMP       M_CASE_0422
M_CASE_0423:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAPHIC_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0421
M_CASE_0422:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0426
        RJMP       M_CASE_0425
M_CASE_0426:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAPHIC_P2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0421
M_CASE_0425:
 
; CASE OF - vergleiche Einzel-Element ($43)
        CPI        R16, 0x43
        BREQ       M_CASE_0428
        RJMP       M_CASE_0427
M_CASE_0428:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
 
; Zuweisung Ziel /  VAR (PIXCOLOR)
        STS        PIXCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0421
 
; CASE OF ELSE
M_CASE_0427:
 
; Aufruf PROCEDURE (FEHLER_ESC)
        CALL       FEHLER_ESC
 
; ENDCASE;
M_CASE_0421:
 
; PROCEDURE - Ende (IBM_GRAPHIC_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAPHIC_P2_TERMINAL_MODE)
IBM_GRAPHIC_P2_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0432
        RJMP       M_CASE_0430
M_CASE_0432:
 
; CASE OF - vergleiche Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0431
        RJMP       M_CASE_0430
M_CASE_0431:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAPHIC_P2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
M_CASE_0430:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0434
        RJMP       M_CASE_0433
M_CASE_0434:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
M_CASE_0433:
 
; CASE OF - vergleiche Einzel-Element ($50)
        CPI        R16, 0x50
        BREQ       M_CASE_0436
        RJMP       M_CASE_0435
M_CASE_0436:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWPOINT)
        CALL       GRAFIKDRAWPOINT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
M_CASE_0435:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0438
        RJMP       M_CASE_0437
M_CASE_0438:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWLINE)
        CALL       GRAFIKDRAWLINE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
M_CASE_0437:
 
; CASE OF - vergleiche Einzel-Element ($52)
        CPI        R16, 0x52
        BREQ       M_CASE_0440
        RJMP       M_CASE_0439
M_CASE_0440:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWRECTANGLE)
        CALL       GRAFIKDRAWRECTANGLE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
M_CASE_0439:
 
; CASE OF - vergleiche Einzel-Element ($46)
        CPI        R16, 0x46
        BREQ       M_CASE_0442
        RJMP       M_CASE_0441
M_CASE_0442:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWFULLRECTANGLE)
        CALL       GRAFIKDRAWFULLRECTANGLE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0429
 
; CASE OF ELSE
M_CASE_0441:
 
; Aufruf PROCEDURE (FEHLER_ESC)
        CALL       FEHLER_ESC
 
; ENDCASE;
M_CASE_0429:
 
; PROCEDURE - Ende (IBM_GRAPHIC_P2_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (CONOUT)
CONOUT:
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_EIN)
        LDS        R16, KURSOR_EIN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0443
        RJMP       M_IF_0444
M_IF_0443:
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; IF_THEN - Ende
M_IF_0444:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; CASE OF - Byte-VAR (TERMMODE)
        LDS        R16, TERMMODE
 
; CASE OF - vergleiche Einzel-Element (NORMAL_TM)
        CPI        R16, 0x00
        BREQ       M_CASE_0448
        RJMP       M_CASE_0447
M_CASE_0448:
 
; Aufruf PROCEDURE (NORMAL_TERMINAL_MODE)
        CALL       NORMAL_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0447:
 
; CASE OF - vergleiche Einzel-Element (IBM_ESC_TM)
        CPI        R16, 0x01
        BREQ       M_CASE_0450
        RJMP       M_CASE_0449
M_CASE_0450:
 
; Aufruf PROCEDURE (IBM_ESC_TERMINAL_MODE)
        CALL       IBM_ESC_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0449:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM)
        CPI        R16, 0x02
        BREQ       M_CASE_0452
        RJMP       M_CASE_0451
M_CASE_0452:
 
; Aufruf PROCEDURE (IBM_CSI_TERMINAL_MODE)
        CALL       IBM_CSI_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0451:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR)
        CPI        R16, 0x03
        BREQ       M_CASE_0454
        RJMP       M_CASE_0453
M_CASE_0454:
 
; Aufruf PROCEDURE (IBM_CSI_PAR_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0453:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_ZEILE)
        CPI        R16, 0x04
        BREQ       M_CASE_0456
        RJMP       M_CASE_0455
M_CASE_0456:
 
; Aufruf PROCEDURE (IBM_CSI_PAR_ZEILE_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_ZEILE_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0455:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_XTERM)
        CPI        R16, 0x05
        BREQ       M_CASE_0458
        RJMP       M_CASE_0457
M_CASE_0458:
 
; Aufruf PROCEDURE (IBM_CSI_PAR_XTERM_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_XTERM_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0457:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAPHIC_TM)
        CPI        R16, 0x06
        BREQ       M_CASE_0460
        RJMP       M_CASE_0459
M_CASE_0460:
 
; Aufruf PROCEDURE (IBM_GRAPHIC_TERMINAL_MODE)
        CALL       IBM_GRAPHIC_TERMINAL_MODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0446
M_CASE_0459:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAPHIC_P2_TM)
        CPI        R16, 0x07
        BREQ       M_CASE_0462
        RJMP       M_CASE_0461
M_CASE_0462:
 
; Aufruf PROCEDURE (IBM_GRAPHIC_P2_TERMINAL_MODE)
        CALL       IBM_GRAPHIC_P2_TERMINAL_MODE
 
; ENDCASE;
M_CASE_0461:
M_CASE_0446:
 
; PROCEDURE - Ende (CONOUT)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_0463:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_0466
        CLR        R16
        RJMP       M_VERGL_0467
M_VERGL_0466:
        SER        R16
M_VERGL_0467:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0464
        RJMP       M_WHILE_0465
M_WHILE_0464:
 
; SetBit(LED_GN)
        SBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0463
M_WHILE_0465:
 
; ClearBit(LED_GN)
        CBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_0471
        CLR        R16
        RJMP       M_VERGL_0472
M_VERGL_0471:
        SER        R16
M_VERGL_0472:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0468
        RJMP       M_IF_0469
M_IF_0468:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, XON
        MOV        R2, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; IF_THEN - Ende
M_IF_0469:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER_PORT)
        CALL       INIT_SER_PORT
 
; ClearBit(LED_GN)
        CBI        PORTD, 7
 
; ClearBit(VS1_GS2)
        CBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, XON
        MOV        R2, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; LOOP - Start_Marke
M_LOOP_0473:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; INC(KURSOR_SCHLEIFE) - Word
        LDS        R24, KURSOR_SCHLEIFE
        LDS        R25, KURSOR_SCHLEIFE+1
        ADIW       R25:R24, 1
        STS        KURSOR_SCHLEIFE, R24
        STS        KURSOR_SCHLEIFE+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KURSOR_SCHLEIFE)
        LDS        R16, KURSOR_SCHLEIFE
        LDS        R17, KURSOR_SCHLEIFE+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xF618)
        LDI        R18, LOW(0xF618)
        LDI        R19, HIGH(0xF618)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0477
        CLR        R16
        RJMP       M_VERGL_0478
M_VERGL_0477:
        SER        R16
M_VERGL_0478:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0474
        RJMP       M_IF_0475
M_IF_0474:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_EIN)
        LDS        R16, KURSOR_EIN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0479
        RJMP       M_IF_0480
M_IF_0479:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0481
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0480:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_EIN)
        CALL       SCHALTE_KURSOR_EIN
 
; IF_THEN_ELSE - Ende
M_IF_0481:
 
; IF_THEN - Ende
M_IF_0475:
 
; LOOP - Ende
        RJMP       M_LOOP_0473
 
; *** Unterprogramm Bibliothek ***
; Division von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 24.01.2013
;
; Uebergabe: R16 Divident Low
;            R17 Divident High
;            R18 Divisor Low
;            R18 Divisor High
; Ergebnis:  R16 Quotient Low
;            R17 Quotient High
;            R18 Rest Low 
;            R19 Rest High 
; Temporaere Register: R20,R21,R22


ASM_UP_MDIV16:

        LDI        R20, 16   ; 8 Schritte (R6)

        MOV        R21, R18  ; R21 = Divisor Low
        MOV        R22, R19  ; R22 = Divisor High

        CLR        R18       ; R18 = Rest Low loeschen
        CLR        R19       ; R19 = Rest High loeschen
ASM_UP_MDIV16a:
			      
        LSL        R16       ; Divident Low links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident High
        ROL        R18       ; Rest Low
        ROL        R19       ; Rest High

        CP         R18, R21  ; Test Rest Low - Divisor Low
        CPC        R19, R22  ; Test Rest High - Divisor High

        BRLO       ASM_UP_MDIV16b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R18, R21  ; Rest Low >= Divisor Low abziehen
        SBC        R19, R22  ; Rest High >= Divisor High abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV16b:

        DEC        R20       ; Zaehler - 1
        BRNE       ASM_UP_MDIV16a   ; wiederhole 16 mal



        RET






; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High


        RET






 
; *** Namen-Liste ***
;
; BAUDRATE (C) WORD Wert=0x62A5
; UBRR_VAL (C) WORD Wert=0x0031
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; ZEICHENBREITE (C) WORD Wert=0x0006
; ZEICHENHOEHE (C) WORD Wert=0x000A
; X_ANF (C) WORD Wert=0x000C
; Y_ANF (C) WORD Wert=0x0001
; MAX_SPALTEN (C) WORD Wert=0x004F
; MAX_ZEILEN (C) WORD Wert=0x0017
; CL_WHITE (C) BYTE Wert=0xFF
; CL_BLACK (C) BYTE Wert=0x00
; CL_RED (C) BYTE Wert=0x43
; CL_GREEN (C) BYTE Wert=0x4C
; CL_BLUE (C) BYTE Wert=0xB0
; CL_YELLOW (C) BYTE Wert=0x4F
; CL_PURPLE (C) BYTE Wert=0x73
; CL_AQUA (C) BYTE Wert=0x7C
; CL_GRAY (C) BYTE Wert=0x6A
; NORMAL_TM (C) BYTE Wert=0x00
; IBM_ESC_TM (C) BYTE Wert=0x01
; IBM_CSI_TM (C) BYTE Wert=0x02
; IBM_CSI_TM_PAR (C) BYTE Wert=0x03
; IBM_CSI_TM_PAR_ZEILE (C) BYTE Wert=0x04
; IBM_CSI_TM_PAR_XTERM (C) BYTE Wert=0x05
; IBM_GRAPHIC_TM (C) BYTE Wert=0x06
; IBM_GRAPHIC_P2_TM (C) BYTE Wert=0x07
; FONT6X8 (A) 
; BILD (A) 
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UDR0 (V) BYTECONVAR
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; A16 (B) BIT
; WE (B) BIT
; OE (B) BIT
; VS1_GS2 (B) BIT
; DIR (B) BIT
; LED_GN (B) BIT
; FCOLOR (V) BYTE
; BCOLOR (V) BYTE
; PIXCOLOR (V) BYTE
; ZEICHEN (V) BYTE
; X_KUR_POS (V) WORD
; Y_KUR_POS (V) WORD
; X_PIX_POS (V) WORD
; Y_PIX_POS (V) WORD
; X_END_POS (V) WORD
; Y_END_POS (V) WORD
; KURSOR_SCHLEIFE (V) WORD
; KURSOR_EIN (V) BOOLEAN
; KURARR_AKTUELL (V) BOOLEAN
; KURSOR_ARRAY (Y) BYTE
; TERMMODE (V) BYTE
; CSI_PARAMETER1 (V) WORD
; CSI_PARAMETER2 (V) WORD
; DELTA_X (V) WORD
; DELTA_Y (V) WORD
; INITPORTS (P) 
; INIT_SER_PORT (P) 
; WAIT_MS (P) 
; RANDOM (F) 
; CLEAR_RAM (P) 
; SCREENROLL (P) 
; TOGGLE_RAMPAGE (P) 
; RESET_FORM (P) 
; WRITE_BILD (P) 
; INIT_BILD (P) 
; SET_POINT (P) 
; GRAFIKDRAWPOINT (P) 
; SET_POINT_POS (P) 
; LINE_TO (P) 
; GRAFIKDRAWLINE (P) 
; DRAW_REC (P) 
; GRAFIKDRAWRECTANGLE (P) 
; DRAW_FULL_REC (P) 
; GRAFIKDRAWFULLRECTANGLE (P) 
; WRITE_CHAR (P) 
; VRAM_TO_PUFFER (P) 
; PUFFER_TO_VRAM (P) 
; SCHALTE_KURSOR_EIN (P) 
; SCHALTE_KURSOR_AUS (P) 
; DELETE_EOL (P) 
; DELETE_BOL (P) 
; DELETE_LINE (P) 
; DELETE_LINE_SCR_ROLL (P) 
; INSERT_LINE_SCR_ROLL (P) 
; SET_CURSOR_POSITION (P) 
; CURSOR_RIGHT (P) 
; WRITELN_CHAR_RP (P) 
; FEHLER_ESC (P) 
; FEHLER_ESC_MZ (P) 
; FEHLER_ESC_CSI (P) 
; FEHLER_ESC_CSI_MZ (P) 
; FEHLER_ESC_CSI_PAR (P) 
; FEHLER_ESC_CSI_PAR_MZ (P) 
; FEHLER_ESC_CSI_PAR_ZEILE (P) 
; FEHLER_ESC_CSI_PAR_ZEILE_MZ (P) 
; NORMAL_TERMINAL_MODE (P) 
; IBM_ESC_TERMINAL_MODE (P) 
; IBM_CSI_TERMINAL_MODE (P) 
; IBM_CSI_PAR_TERMINAL_MODE (P) 
; IBM_CSI_PAR_ZEILE_TERMINAL_MODE (P) 
; IBM_CSI_PAR_XTERM_TERMINAL_MODE (P) 
; IBM_GRAPHIC_TERMINAL_MODE (P) 
; IBM_GRAPHIC_P2_TERMINAL_MODE (P) 
; CONOUT (P) 
; SENDE_ZEICHEN (P) 
; RX_PUFFER_ABFRAGEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INITPORTS;
; PROCEDURE INIT_SER_PORT;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; FUNCTION RANDOM (WERT : BYTE) : BYTE;
; PROCEDURE CLEAR_RAM (X1 : WORD) (X2 : WORD) (ADRESSE : WORD);
; PROCEDURE SCREENROLL;
; PROCEDURE TOGGLE_RAMPAGE;
; PROCEDURE RESET_FORM;
; PROCEDURE WRITE_BILD (X1 : BYTE) (X2 : BYTE) (B_WERT : BYTE) (ADRESSE : WORD) (B_POINTER : WORD);
; PROCEDURE INIT_BILD;
; PROCEDURE SET_POINT (ADRESSE : WORD);
; PROCEDURE GRAFIKDRAWPOINT;
; PROCEDURE SET_POINT_POS (X_POINT_POS : WORD) (Y_POINT_POS : WORD) (ADRESSE : WORD);
; PROCEDURE LINE_TO (X1 : WORD) (XP_ANF : WORD) (XP_END : WORD) (Y1 : WORD) (YP_ANF : WORD) (YP_END : WORD);
; PROCEDURE GRAFIKDRAWLINE;
; PROCEDURE DRAW_REC (ADRESSE : WORD) (W1 : WORD) (YR_POS : WORD);
; PROCEDURE GRAFIKDRAWRECTANGLE;
; PROCEDURE DRAW_FULL_REC (ADRESSE : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE GRAFIKDRAWFULLRECTANGLE;
; PROCEDURE WRITE_CHAR (FONTPTR : WORD) (X_CNT : WORD) (Y_CNT : WORD) (FONTCOLOR : BYTE) (FONTZEILE : BYTE) (ADRESSE : WORD);
; PROCEDURE VRAM_TO_PUFFER (ADRESSE : WORD) (X_CNT : WORD) (Y_CNT : WORD) (KURPOS : WORD);
; PROCEDURE PUFFER_TO_VRAM (ADRESSE : WORD) (X_CNT : WORD) (Y_CNT : WORD) (KURPOS : WORD);
; PROCEDURE SCHALTE_KURSOR_EIN;
; PROCEDURE SCHALTE_KURSOR_AUS;
; PROCEDURE DELETE_EOL (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_BOL (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_LINE (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_LINE_SCR_ROLL (X1 : WORD) (Y1 : WORD) (ADRESSE_VON : WORD) (ADRESSE_BIS : WORD);
; PROCEDURE INSERT_LINE_SCR_ROLL;
; PROCEDURE SET_CURSOR_POSITION (ZEILE : WORD) (SPALTE : WORD);
; PROCEDURE CURSOR_RIGHT;
; PROCEDURE WRITELN_CHAR_RP;
; PROCEDURE FEHLER_ESC;
; PROCEDURE FEHLER_ESC_MZ (LOK_ZEICHEN : BYTE);
; PROCEDURE FEHLER_ESC_CSI;
; PROCEDURE FEHLER_ESC_CSI_MZ (LOK_ZEICHEN : BYTE);
; PROCEDURE FEHLER_ESC_CSI_PAR;
; PROCEDURE FEHLER_ESC_CSI_PAR_MZ (LOK_ZEICHEN : BYTE);
; PROCEDURE FEHLER_ESC_CSI_PAR_ZEILE;
; PROCEDURE FEHLER_ESC_CSI_PAR_ZEILE_MZ (LOK_ZEICHEN : BYTE);
; PROCEDURE NORMAL_TERMINAL_MODE;
; PROCEDURE IBM_ESC_TERMINAL_MODE;
; PROCEDURE IBM_CSI_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_TERMINAL_MODE (ZAEHLER : WORD);
; PROCEDURE IBM_CSI_PAR_ZEILE_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_XTERM_TERMINAL_MODE;
; PROCEDURE IBM_GRAPHIC_TERMINAL_MODE;
; PROCEDURE IBM_GRAPHIC_P2_TERMINAL_MODE;
; PROCEDURE CONOUT;
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE RX_PUFFER_ABFRAGEN;
 
; *** Konstanten-ARRAYs ***
;
 
FONT6X8:
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x70
 .db    0x70,0x20
 .db    0x20,0x00
 .db    0x20,0x00
 .db    0xD8,0xD8
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x50
 .db    0xF8,0x50
 .db    0x50,0xF8
 .db    0x50,0x00
 .db    0x10,0x70
 .db    0x08,0x30
 .db    0x40,0x38
 .db    0x20,0x00
 .db    0x98,0x98
 .db    0x40,0x20
 .db    0x10,0xC8
 .db    0xC8,0x00
 .db    0x10,0x28
 .db    0x28,0x10
 .db    0xA8,0x48
 .db    0xB0,0x00
 .db    0x30,0x30
 .db    0x10,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x10
 .db    0x10,0x10
 .db    0x10,0x10
 .db    0x20,0x00
 .db    0x10,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x10,0x00
 .db    0x00,0x50
 .db    0x70,0xF8
 .db    0x70,0x50
 .db    0x00,0x00
 .db    0x00,0x20
 .db    0x20,0xF8
 .db    0x20,0x20
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x30
 .db    0x30,0x10
 .db    0x00,0x00
 .db    0x00,0xF8
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x30
 .db    0x30,0x00
 .db    0x00,0x80
 .db    0x40,0x20
 .db    0x10,0x08
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0xC8,0xA8
 .db    0x98,0x88
 .db    0x70,0x00
 .db    0x20,0x30
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x80,0x60
 .db    0x10,0x08
 .db    0xF8,0x00
 .db    0x70,0x88
 .db    0x80,0x70
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0x40,0x60
 .db    0x50,0x48
 .db    0xF8,0x40
 .db    0x40,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0x60,0x10
 .db    0x08,0x78
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0xF8,0x80
 .db    0x40,0x20
 .db    0x10,0x10
 .db    0x10,0x00
 .db    0x70,0x88
 .db    0x88,0x70
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x88,0xF0
 .db    0x80,0x40
 .db    0x30,0x00
 .db    0x00,0x00
 .db    0x30,0x30
 .db    0x00,0x30
 .db    0x30,0x00
 .db    0x00,0x00
 .db    0x30,0x30
 .db    0x00,0x30
 .db    0x30,0x10
 .db    0x40,0x20
 .db    0x10,0x08
 .db    0x10,0x20
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0xF8,0x00
 .db    0x00,0xF8
 .db    0x00,0x00
 .db    0x10,0x20
 .db    0x40,0x80
 .db    0x40,0x20
 .db    0x10,0x00
 .db    0x70,0x88
 .db    0x80,0x60
 .db    0x20,0x00
 .db    0x20,0x00
 .db    0x70,0x88
 .db    0xE8,0xA8
 .db    0xE8,0x08
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0xF8,0x88
 .db    0x88,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0x70,0x88
 .db    0x08,0x08
 .db    0x08,0x88
 .db    0x70,0x00
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x08,0x08
 .db    0xF8,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x08,0x08
 .db    0x08,0x00
 .db    0x70,0x88
 .db    0x08,0xE8
 .db    0x88,0x88
 .db    0xF0,0x00
 .db    0x88,0x88
 .db    0x88,0xF8
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x70,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x70,0x00
 .db    0x80,0x80
 .db    0x80,0x80
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x88,0x48
 .db    0x28,0x18
 .db    0x28,0x48
 .db    0x88,0x00
 .db    0x08,0x08
 .db    0x08,0x08
 .db    0x08,0x08
 .db    0xF8,0x00
 .db    0x88,0xD8
 .db    0xA8,0x88
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x88,0x98
 .db    0xA8,0xC8
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x08,0x08
 .db    0x08,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0xA8,0x48
 .db    0xB0,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x48,0x88
 .db    0x88,0x00
 .db    0x70,0x88
 .db    0x08,0x70
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0xF8,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x00
 .db    0x88,0x88
 .db    0xA8,0xA8
 .db    0xA8,0xA8
 .db    0x50,0x00
 .db    0x88,0x88
 .db    0x50,0x20
 .db    0x50,0x88
 .db    0x88,0x00
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x78,0x40
 .db    0x20,0x10
 .db    0x08,0x08
 .db    0x78,0x00
 .db    0x70,0x10
 .db    0x10,0x10
 .db    0x10,0x10
 .db    0x70,0x00
 .db    0x00,0x08
 .db    0x10,0x20
 .db    0x40,0x80
 .db    0x00,0x00
 .db    0x70,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x70,0x00
 .db    0x20,0x50
 .db    0x88,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xFC
 .db    0x30,0x30
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x70,0x80
 .db    0xF0,0x88
 .db    0xF0,0x00
 .db    0x08,0x08
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x08,0x88
 .db    0x70,0x00
 .db    0x80,0x80
 .db    0xF0,0x88
 .db    0x88,0x88
 .db    0xF0,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x78,0x08
 .db    0x70,0x00
 .db    0x60,0x10
 .db    0x10,0x78
 .db    0x10,0x10
 .db    0x10,0x00
 .db    0x00,0x00
 .db    0xF0,0x88
 .db    0x88,0xF0
 .db    0x80,0x70
 .db    0x08,0x08
 .db    0x38,0x48
 .db    0x48,0x48
 .db    0x48,0x00
 .db    0x20,0x00
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x60,0x00
 .db    0x40,0x00
 .db    0x60,0x40
 .db    0x40,0x40
 .db    0x48,0x30
 .db    0x08,0x08
 .db    0x48,0x28
 .db    0x18,0x28
 .db    0x48,0x00
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x60,0x00
 .db    0x00,0x00
 .db    0x58,0xA8
 .db    0xA8,0x88
 .db    0x88,0x00
 .db    0x00,0x00
 .db    0x38,0x48
 .db    0x48,0x48
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x00,0x00
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x78,0x08
 .db    0x00,0x00
 .db    0xF0,0x88
 .db    0x88,0x88
 .db    0xF0,0x80
 .db    0x00,0x00
 .db    0x68,0x90
 .db    0x10,0x10
 .db    0x38,0x00
 .db    0x00,0x00
 .db    0x70,0x08
 .db    0x70,0x80
 .db    0x70,0x00
 .db    0x00,0x10
 .db    0x78,0x10
 .db    0x10,0x50
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x48,0x68
 .db    0x50,0x00
 .db    0x00,0x00
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x88,0x88
 .db    0xA8,0xF8
 .db    0x50,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x30,0x48
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x48,0x70
 .db    0x20,0x18
 .db    0x00,0x00
 .db    0x78,0x40
 .db    0x30,0x08
 .db    0x78,0x00
 .db    0x60,0x10
 .db    0x10,0x18
 .db    0x10,0x10
 .db    0x60,0x00
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x30,0x40
 .db    0x40,0xC0
 .db    0x40,0x40
 .db    0x30,0x00
 .db    0x50,0x28
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x70
 .db    0xD8,0x88
 .db    0x88,0xF8
 .db    0x00,0x00
 
BILD:
 .db    0xDB,0xDB
 .db    0xDB,0xDB
 .db    0x9B,0x9B
 .db    0x6B,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0xA7
 .db    0x7B,0x7B
 .db    0x7A,0x7E
 .db    0x7E,0xB9
 .db    0xB9,0xBD
 .db    0xB9,0xBD
 .db    0xBD,0x7A
 .db    0x3F,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x7A
 .db    0x3F,0x7A
 .db    0x7A,0x7A
 .db    0x7A,0x7A
 .db    0x7A,0x6F
 .db    0x6F,0x7F
 .db    0x6F,0x7F
 .db    0x7F,0x7F
 .db    0xDF,0xDB
 .db    0xDF,0x9B
 .db    0xAF,0x6F
 .db    0x6F,0x3F
 .db    0x6B,0x3F
 .db    0x3F,0x3F
 .db    0x7E,0x7E
 .db    0xBD,0x7E
 .db    0xBD,0xB9
 .db    0xBD,0xB9
 .db    0xF8,0xBD
 .db    0xBD,0x3F
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0xAF,0x6F
 .db    0xAF,0x6F
 .db    0xAF,0x6F
 .db    0xDB,0xDF
 .db    0xDB,0xDB
 .db    0xAF,0xAB
 .db    0x6F,0x3F
 .db    0x3F,0x7E
 .db    0x7E,0xB9
 .db    0xB9,0xBD
 .db    0xB9,0xBD
 .db    0xBD,0xF8
 .db    0xBD,0xF8
 .db    0xF8,0xFC
 .db    0x7E,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0xAF
 .db    0xAF,0xAF
 .db    0xAF,0xAF
 .db    0xDF,0xDB
 .db    0xDF,0x9F
 .db    0xDB,0x6F
 .db    0x7E,0x7A
 .db    0xBD,0x7E
 .db    0xBD,0x7E
 .db    0xBD,0xB9
 .db    0xF8,0xBD
 .db    0xFD,0xF8
 .db    0xFC,0xF8
 .db    0xFD,0xFC
 .db    0xF8,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x6B,0x6F
 .db    0xAF,0x7F
 .db    0xAF,0x6F
 .db    0xDB,0xDF
 .db    0xDF,0xDB
 .db    0x9B,0x7A
 .db    0x7E,0xB9
 .db    0xB9,0xBD
 .db    0xBD,0xBD
 .db    0xBD,0xF8
 .db    0xF8,0xFC
 .db    0xF8,0xFC
 .db    0xFC,0xFD
 .db    0xFC,0xFD
 .db    0xFC,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x7F
 .db    0x7F,0x7F
 .db    0x6F,0x7F
 .db    0xDB,0xDB
 .db    0xAF,0x3F
 .db    0x7E,0x7E
 .db    0xBD,0xB9
 .db    0xF8,0xBD
 .db    0xF8,0xBD
 .db    0xFC,0xF8
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0x7F,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x6B,0x6F
 .db    0x7F,0x6F
 .db    0x7F,0x6F
 .db    0xAF,0x6B
 .db    0x6B,0x3F
 .db    0x7E,0xBD
 .db    0xB9,0xBD
 .db    0xF8,0xFC
 .db    0xF8,0xFC
 .db    0xFC,0xFD
 .db    0xFC,0xFC
 .db    0xFD,0xFD
 .db    0xFC,0xFD
 .db    0xFD,0xFD
 .db    0xFC,0xFD
 .db    0xFC,0xFD
 .db    0xFC,0xFC
 .db    0xBD,0xBD
 .db    0xB9,0xB9
 .db    0xB9,0x7E
 .db    0x3F,0x7A
 .db    0x3F,0x7A
 .db    0x3F,0x3F
 .db    0x3F,0x6B
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6F
 .db    0x6F,0x6F
 .db    0x6F,0x6F
 .db    0x6B,0x6B
 .db    0x97,0x3F
 .db    0xBD,0xB9
 .db    0xF8,0xBD
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFD
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xF8
 .db    0xFD,0xBD
 .db    0xF8,0xB9
 .db    0xF8,0xB9
 .db    0xBD,0x7E
 .db    0xBD,0x7E
 .db    0x7E,0x3F
 .db    0x3F,0xB5
 .db    0xB6,0x3F
 .db    0xA7,0x6B
 .db    0xA7,0x6B
 .db    0x6B,0x7A
 .db    0x7A,0x3F
 .db    0x7A,0x3F
 .db    0x3F,0x3F
 .db    0x6F,0x3F
 .db    0x7F,0x3F
 .db    0x7F,0x3F
 .db    0x6F,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0xB9
 .db    0xB9,0xBD
 .db    0xF8,0xFC
 .db    0xFC,0xFC
 .db    0xFC,0xFD
 .db    0xFC,0xFD
 .db    0xFD,0xFD
 .db    0xFD,0xFD
 .db    0xFC,0xFD
 .db    0xFC,0xFC
 .db    0xFC,0xFC
 .db    0xF8,0xF8
 .db    0xF8,0xF8
 .db    0xBD,0xBD
 .db    0xBD,0xBD
 .db    0xB9,0xB9
 .db    0x7E,0x7E
 .db    0x3F,0x3F
 .db    0x6B,0x97
 .db    0x6B,0x3F
 .db    0x7A,0x7A
 .db    0x6B,0x97
 .db    0x97,0xA7
 .db    0x6B,0x7A
 .db    0x7A,0x7A
 .db    0x3F,0x3F
 .db    0x3F,0x6F
 .db    0x6F,0x6F
 .db    0x3F,0x3F
 .db    0x3F,0x6E
 .db    0x9D,0xCC
 .db    0x97,0x6B
 .db    0x6B,0x7E
 .db    0xBD,0xB9
 .db    0xFD,0xF8
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xF8
 .db    0xFD,0xBD
 .db    0xF8,0xB9
 .db    0xF8,0xB9
 .db    0xBD,0x7E
 .db    0xBD,0x7E
 .db    0x7E,0x3F
 .db    0xAB,0x7F
 .db    0xAF,0x6F
 .db    0x7F,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x3F
 .db    0x7F,0x3F
 .db    0x7F,0x3F
 .db    0x7F,0x3F
 .db    0x6F,0x3F
 .db    0x7E,0x3F
 .db    0x9D,0xCC
 .db    0xCD,0xCC
 .db    0x6B,0x97
 .db    0x3F,0xB9
 .db    0xB9,0xBD
 .db    0xF8,0xFC
 .db    0xFC,0xFD
 .db    0xFC,0xFD
 .db    0xFD,0xFD
 .db    0xFC,0xFC
 .db    0xFC,0xFC
 .db    0xF8,0xF8
 .db    0xF8,0xF8
 .db    0xBD,0xBD
 .db    0xBD,0xBD
 .db    0xB9,0xB9
 .db    0xB9,0xB9
 .db    0x7A,0x3F
 .db    0x7F,0xAF
 .db    0x7F,0xAF
 .db    0xAF,0xAF
 .db    0x7F,0x7F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x3F
 .db    0x3F,0x6F
 .db    0x3F,0x7F
 .db    0x7A,0xB9
 .db    0xB9,0xB9
 .db    0x7A,0x3F
 .db    0x6E,0xCC
 .db    0xCC,0xCD
 .db    0x97,0x6B
 .db    0x6B,0x7E
 .db    0xBD,0xB9
 .db    0xF8,0xF8
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xFC
 .db    0xFD,0xF8
 .db    0xFD,0xF8
 .db    0xF8,0xBD
 .db    0xF8,0xB9
 .db    0xBD,0x7E
 .db    0xBD,0x7E
 .db    0xB9,0x7A
 .db    0x7E,0x3F
 .db    0x6B,0x6F
 .db    0xBF,0xAB
 .db    0xBF,0xAB
 .db    0xEB,0xAF
 .db    0xBF,0x7F
 .db    0xAF,0x3F
 .db    0x6B,0x3F
 .db    0x7B,0x3F
 .db    0x3F,0x3F
 .db    0x6B,0x3F
 .db    0x7A,0x7A
 .db    0xF5,0xF4
 .db    0xF5,0xB5
 .db    0xBA,0x7A
 .db    0x7A,0x7A
 .db    0xB9,0x7A
 .db    0x7E,0x9D
 .db    0x6B,0x97
 .db    0x97,0x7E
 .db    0x7E,0xBD
 .db    0xBD,0xF8
 .db    0xFC,0xFC
 .db    0xFC,0xFC
 .db    0xFC,0xFC
 .db    0xF8,0xF8
 .db    0xBD,0xBD
 .db    0xBD,0xBD
 .db    0xB9,0xB9
 .db    0xB9,0xB9
 .db    0x7E,0x7A
 .db    0x7A,0xA7
 .db    0xA7,0x7B
 .db    0x7F,0xAF
 .db    0xAF,0xBF
 .db    0xBF,0xEF
 .db    0xBF,0xEB
 .db    0xAF,0xBF
 .db    0xAB,0x7F
 .db    0x6B,0x7B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x3F,0x7A
 .db    0xB5,0xF5
 .db    0xB9,0xB9
 .db    0xB5,0x7A
 .db    0x7A,0xB9
 .db    0xB9,0xB9
 .db    0xB5,0x7A
 .db    0x97,0x6B
 .db    0x97,0x3F
 .db    0xB9,0x7E
 .db    0xF8,0xBD
 .db    0xFC,0xF8
 .db    0xFD,0xF8
 .db    0xFC,0xBD
 .db    0xF8,0xB9
 .db    0xBD,0xB9
 .db    0xBD,0x7E
 .db    0xB9,0x7E
 .db    0x7E,0x3F
 .db    0x7B,0x7B
 .db    0xAB,0xA7
 .db    0xA7,0x3F
 .db    0xAF,0x7F
 .db    0xEB,0xAF
 .db    0xFF,0xEF
 .db    0xFF,0xEB
 .db    0xEF,0xAF
 .db    0xBF,0x7F
 .db    0xAF,0x3F
 .db    0x7B,0x6B
 .db    0x7B,0x6B
 .db    0x7B,0x3F
 .db    0x7B,0x3F
 .db    0x6B,0x3F
 .db    0x7A,0x3F
 .db    0x7A,0x3F
 .db    0xF4,0xB9
 .db    0xF4,0xB5
 .db    0xB9,0x7A
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x7E,0xB9
 .db    0xB9,0xBD
 .db    0xBD,0xF8
 .db    0xBD,0xBD
 .db    0xBD,0xBD
 .db    0xB9,0xB9
 .db    0xB9,0xB9
 .db    0x7E,0x7E
 .db    0x3F,0x3F
 .db    0x6B,0x7B
 .db    0x7B,0xA7
 .db    0x7B,0xA7
 .db    0x6B,0xAB
 .db    0x7F,0xAF
 .db    0xBF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEB
 .db    0xBF,0xAF
 .db    0x7F,0x6B
 .db    0x7B,0xA7
 .db    0x6B,0x7B
 .db    0x7B,0x7B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0x6B
 .db    0x3F,0x3F
 .db    0x3F,0x7A
 .db    0xB9,0xF4
 .db    0xB9,0xB9
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x6B,0x7A
 .db    0xB9,0x7E
 .db    0xBD,0xB9
 .db    0xBD,0xB9
 .db    0xBD,0x7E
 .db    0xB9,0x7E
 .db    0xB9,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x7B,0x3F
 .db    0x7B,0x6B
 .db    0x7B,0x6B
 .db    0x7B,0x7F
 .db    0xAF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xBF
 .db    0xEF,0xAF
 .db    0xAF,0x6F
 .db    0xA7,0x7B
 .db    0xA7,0x6B
 .db    0xAB,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x6B
 .db    0x7B,0x3F
 .db    0x7B,0x3F
 .db    0x7B,0x3F
 .db    0x6B,0x3F
 .db    0x7A,0x7A
 .db    0x3F,0x6B
 .db    0x6B,0x97
 .db    0x97,0x6B
 .db    0x3F,0xB9
 .db    0x7E,0xB9
 .db    0xB9,0xB9
 .db    0x7E,0xB9
 .db    0x7A,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0x3F,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x7B
 .db    0x3F,0x7F
 .db    0xAF,0xBF
 .db    0xEB,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xBF,0xBF
 .db    0xAF,0xAB
 .db    0x6B,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x6B,0x7B
 .db    0x6B,0x7B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x7A,0x3F
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x6B,0x3F
 .db    0x7E,0x3F
 .db    0x6B,0x6B
 .db    0xC3,0x97
 .db    0xC3,0x97
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x3F,0x3F
 .db    0x7A,0x3F
 .db    0x6B,0x3F
 .db    0x6B,0x7F
 .db    0xBF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEF,0xAF
 .db    0xBF,0x7F
 .db    0x7F,0xA7
 .db    0xE7,0xA7
 .db    0xE7,0xA7
 .db    0xBB,0xA7
 .db    0xAB,0x7B
 .db    0xAB,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x6B
 .db    0x7B,0x6B
 .db    0x7B,0x3F
 .db    0x7A,0x3F
 .db    0x3F,0x6B
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x97,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0xB5,0xB5
 .db    0x7A,0x7A
 .db    0x3F,0x7F
 .db    0x7F,0xAF
 .db    0xBF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEF
 .db    0xAF,0xAF
 .db    0x7F,0x7B
 .db    0xA7,0xA7
 .db    0xA7,0xBB
 .db    0xA7,0xA7
 .db    0xA7,0xAB
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x7B,0x7B
 .db    0x7B,0xA7
 .db    0x6B,0x6B
 .db    0x7A,0x3F
 .db    0x6F,0x3F
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0xC3,0x97
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0x97
 .db    0xC3,0x97
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x3F,0x7A
 .db    0xB5,0x7A
 .db    0xB5,0x3F
 .db    0xAF,0x7F
 .db    0xEF,0xBF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xFF,0xBF
 .db    0xBF,0x7F
 .db    0xAF,0x3F
 .db    0xA7,0x6B
 .db    0xAB,0xA7
 .db    0xAB,0xA7
 .db    0xE7,0xA7
 .db    0xE7,0xA7
 .db    0xE7,0xA7
 .db    0xAB,0x7B
 .db    0xAB,0x7B
 .db    0xA7,0x6B
 .db    0x3F,0x3F
 .db    0x6F,0x9B
 .db    0x3F,0x6B
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x97,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x3F
 .db    0xB5,0xF0
 .db    0x7A,0x3F
 .db    0x7F,0xAF
 .db    0xAF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEF
 .db    0xBF,0xBF
 .db    0x7F,0x7F
 .db    0x6B,0x7B
 .db    0x7B,0xA7
 .db    0x7B,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xAB
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x7A,0x3F
 .db    0x6F,0x6F
 .db    0xAF,0x3F
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0x97
 .db    0xC3,0x97
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x3F,0x3F
 .db    0x9D,0x6E
 .db    0x7F,0x7F
 .db    0xBF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEF,0xAF
 .db    0xBF,0x7F
 .db    0x6B,0x6B
 .db    0x7B,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x7B
 .db    0xAB,0xA7
 .db    0xBB,0xA7
 .db    0xE7,0xA7
 .db    0xAB,0x6B
 .db    0x3F,0x7A
 .db    0x3F,0x9B
 .db    0x9B,0xAF
 .db    0x3F,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x97,0x97
 .db    0x97,0x6B
 .db    0x6E,0x6E
 .db    0x6E,0x9D
 .db    0x3F,0x7F
 .db    0xAF,0xBF
 .db    0xBF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEB,0xBF
 .db    0xAF,0xAF
 .db    0x3F,0x6B
 .db    0x6B,0x7B
 .db    0x6B,0x7B
 .db    0x6B,0x7B
 .db    0x6B,0x7B
 .db    0x7B,0xA7
 .db    0x7B,0xA7
 .db    0xA7,0xA7
 .db    0x7B,0x7B
 .db    0xFE,0x7E
 .db    0x3F,0x6F
 .db    0xAF,0x9B
 .db    0xDB,0x3F
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0x97
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0x97
 .db    0x97,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0x6E,0x6F
 .db    0xBF,0xAF
 .db    0xEF,0xBF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xFF,0xAF
 .db    0xBF,0x7F
 .db    0xAF,0x3F
 .db    0x6B,0x3F
 .db    0x7B,0x3F
 .db    0x7B,0x6B
 .db    0x7B,0x6B
 .db    0xA7,0x6B
 .db    0xA7,0x6B
 .db    0x6E,0x3F
 .db    0x6E,0x3F
 .db    0xBE,0xFD
 .db    0xF9,0x6B
 .db    0x9B,0xAF
 .db    0xDB,0xDB
 .db    0x6B,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x6B,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0x9D,0x6F
 .db    0x7F,0xAF
 .db    0xAF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEF
 .db    0xAF,0xAF
 .db    0x7F,0x6E
 .db    0x6F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x6B
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0x6E
 .db    0x6E,0x9D
 .db    0x6E,0x9D
 .db    0xBE,0xBE
 .db    0xF9,0x3F
 .db    0xAB,0x9B
 .db    0xDB,0xDB
 .db    0xDF,0x9B
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0x97
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x6B,0x6E
 .db    0x9D,0x9D
 .db    0xDC,0xCC
 .db    0xDD,0x6E
 .db    0xAF,0x7F
 .db    0xBF,0xAF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEB
 .db    0xEF,0xAB
 .db    0xBF,0x6F
 .db    0xDF,0x6B
 .db    0xA7,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x6B,0x3F
 .db    0x6E,0x6E
 .db    0x9D,0x6E
 .db    0x9D,0x6E
 .db    0xBA,0xBE
 .db    0xBA,0x7E
 .db    0x6F,0xAF
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0x9B,0x6B
 .db    0x6B,0x97
 .db    0x6B,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x3F,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0xDC
 .db    0xCC,0xCC
 .db    0x6F,0xAF
 .db    0xAF,0xBF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEB,0xBF
 .db    0xAB,0x7F
 .db    0x6F,0x9F
 .db    0x6B,0x3F
 .db    0x3F,0x6E
 .db    0x3F,0x7E
 .db    0x3F,0x3F
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0x9D,0x9D
 .db    0x7E,0x7E
 .db    0xBE,0x7E
 .db    0x6F,0x6F
 .db    0xAF,0x9B
 .db    0xDF,0xDB
 .db    0xDF,0x6F
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0x97
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x6E,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0xCC
 .db    0xDD,0xCC
 .db    0xAE,0x7F
 .db    0xAF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xFF,0xAF
 .db    0xBF,0x7F
 .db    0x7F,0x9F
 .db    0x3F,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x7F,0x3F
 .db    0x9D,0x6E
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x3F,0x3F
 .db    0x3F,0x7B
 .db    0x3F,0x9B
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0xDF,0xDB
 .db    0x6F,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x97
 .db    0x97,0xC3
 .db    0xC3,0xC3
 .db    0xC3,0xC3
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0xDC
 .db    0xCC,0xDC
 .db    0x9D,0x7F
 .db    0xAB,0xBF
 .db    0xBF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEB
 .db    0xAF,0xAF
 .db    0x7F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x7E
 .db    0x7E,0x7E
 .db    0x7E,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x3F,0x6E
 .db    0x7F,0x3F
 .db    0x7B,0x6F
 .db    0xAF,0x9B
 .db    0xDB,0xDB
 .db    0xEF,0x9B
 .db    0x6F,0x6F
 .db    0x9E,0x3F
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0x97
 .db    0xC3,0xC3
 .db    0x6E,0x6E
 .db    0x9D,0x9D
 .db    0xDC,0xCC
 .db    0xDD,0xCC
 .db    0xDC,0x3F
 .db    0xAF,0x7F
 .db    0xEB,0xBF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xBF
 .db    0xEF,0x7F
 .db    0xAF,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x7E
 .db    0xBE,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0x3F,0x9F
 .db    0x3F,0x7A
 .db    0xA7,0x6F
 .db    0x6F,0xAB
 .db    0xDB,0xDB
 .db    0xDF,0x6F
 .db    0x9E,0x9E
 .db    0x6F,0x6F
 .db    0x6B,0x97
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0xDD
 .db    0xCC,0xCC
 .db    0x9D,0x6E
 .db    0x7F,0xAF
 .db    0xAF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xBF,0xAF
 .db    0xAF,0xAB
 .db    0x3F,0x3F
 .db    0x3F,0x7E
 .db    0x7E,0x7E
 .db    0x7E,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x3F,0x6F
 .db    0x3F,0x3F
 .db    0xB7,0x6B
 .db    0xAB,0x6F
 .db    0xDB,0xDB
 .db    0xDF,0x6F
 .db    0x9E,0x9E
 .db    0x9F,0x6F
 .db    0x6F,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0xC3,0x6B
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0xCC
 .db    0xDD,0x9D
 .db    0xDD,0x9D
 .db    0x7F,0x7F
 .db    0xBF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEF,0xAF
 .db    0xBF,0x7F
 .db    0x6F,0x3F
 .db    0x7E,0x7E
 .db    0x7E,0x7E
 .db    0xBE,0x3F
 .db    0x9D,0x6E
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x3F,0x9F
 .db    0x3F,0x7A
 .db    0x7B,0x7B
 .db    0x6F,0xAB
 .db    0x9B,0xDB
 .db    0xDB,0xDB
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x6F,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xDC
 .db    0xCC,0xDC
 .db    0x9D,0x9D
 .db    0x6E,0xAB
 .db    0xAB,0xBF
 .db    0xBF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEB
 .db    0xAF,0xAF
 .db    0x7F,0x3F
 .db    0x7E,0x7E
 .db    0x7E,0x7E
 .db    0x7E,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x3F,0x6F
 .db    0x7A,0x3F
 .db    0x7B,0x7B
 .db    0x6F,0x6F
 .db    0xAF,0x9B
 .db    0xDF,0xDB
 .db    0xAF,0x6F
 .db    0x9F,0x9E
 .db    0x9E,0x6E
 .db    0x3F,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0xCC
 .db    0xDD,0xCC
 .db    0xDC,0x9D
 .db    0x9D,0x6F
 .db    0xAF,0xAB
 .db    0xEF,0xEB
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xFF,0xBF
 .db    0xBF,0x7F
 .db    0xAF,0x3F
 .db    0x7E,0x7E
 .db    0xBE,0x7E
 .db    0x7E,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x3F,0x9F
 .db    0x3F,0x7A
 .db    0x7B,0xB7
 .db    0x6B,0x9B
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0xDF,0x6F
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x6E,0x3F
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xDD
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0x6E,0x3F
 .db    0x7F,0xAF
 .db    0xAF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0xEF
 .db    0xBF,0xBF
 .db    0x7F,0x6F
 .db    0x7E,0xAE
 .db    0x7E,0x7E
 .db    0x3F,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0x9D,0x9D
 .db    0x6B,0x6F
 .db    0x6F,0x3F
 .db    0x7B,0x7B
 .db    0x7B,0x6F
 .db    0xAF,0x9B
 .db    0xDB,0xDB
 .db    0xEF,0x9B
 .db    0x9E,0x6F
 .db    0xCE,0x9E
 .db    0x9E,0x6E
 .db    0x6E,0x3F
 .db    0x6B,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0xCC
 .db    0xDD,0x9D
 .db    0xDC,0x9D
 .db    0x9D,0x3F
 .db    0xAF,0x7F
 .db    0xBF,0xAF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEB
 .db    0xEF,0xAF
 .db    0xAF,0x6F
 .db    0x7F,0x7E
 .db    0x7E,0x3F
 .db    0x3F,0x6E
 .db    0x9D,0x6E
 .db    0xCC,0xCC
 .db    0xCC,0x9D
 .db    0x6B,0x6B
 .db    0x6F,0x3F
 .db    0x7A,0xA7
 .db    0xA7,0x6B
 .db    0x9B,0xAF
 .db    0xDB,0xDB
 .db    0xDF,0xDF
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x9E,0x6F
 .db    0x6E,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xDC
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0x6E,0x6E
 .db    0x6B,0xAB
 .db    0xAF,0xBF
 .db    0xEB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xBF,0xBF
 .db    0xBF,0xBF
 .db    0xAF,0xAF
 .db    0x3F,0x3F
 .db    0x3F,0x6B
 .db    0x3F,0x6E
 .db    0x9D,0x9D
 .db    0x9D,0xCC
 .db    0x9D,0x9D
 .db    0xA7,0x6B
 .db    0x6F,0x3F
 .db    0x7A,0x7B
 .db    0xB7,0x6B
 .db    0xAB,0x9B
 .db    0xDB,0xDB
 .db    0xDF,0xDB
 .db    0xDB,0x6E
 .db    0x9E,0x9E
 .db    0x9F,0x6F
 .db    0x6E,0x3F
 .db    0x3F,0x3F
 .db    0x9D,0x6E
 .db    0xDC,0x9D
 .db    0xDD,0xCC
 .db    0xDD,0x9D
 .db    0x9D,0x3F
 .db    0x6E,0x3F
 .db    0x6B,0x6F
 .db    0xBF,0xAF
 .db    0xEF,0xAF
 .db    0xBF,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x3F
 .db    0xBF,0x7F
 .db    0x7F,0x3F
 .db    0x97,0x6B
 .db    0x6B,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x7B,0x7B
 .db    0x3F,0x3F
 .db    0x7A,0x7B
 .db    0xA7,0x7B
 .db    0x6F,0xAF
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0xDB,0x9B
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x6F,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0x6E,0x6F
 .db    0x3F,0x6B
 .db    0x97,0x97
 .db    0x6B,0x3F
 .db    0x97,0x6F
 .db    0x6B,0x7B
 .db    0x6B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x3F,0x7F
 .db    0x7F,0x6B
 .db    0x6B,0x97
 .db    0x3F,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0xB7,0x7B
 .db    0xB7,0x7A
 .db    0xB5,0x3F
 .db    0xB7,0x3F
 .db    0x6F,0x6F
 .db    0xAF,0x9B
 .db    0xDF,0xDB
 .db    0xDF,0x9F
 .db    0x6F,0x6F
 .db    0x9F,0x9E
 .db    0x9E,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0x3F
 .db    0x6B,0x6B
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x97
 .db    0x97,0x3F
 .db    0x7B,0x3F
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x3F
 .db    0xAF,0x6F
 .db    0x97,0x97
 .db    0x6F,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0xCC,0x6E
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x9B
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0xDF,0xDB
 .db    0x9B,0x6F
 .db    0x9E,0x9F
 .db    0x9E,0x9E
 .db    0x3F,0x3F
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x6B
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0x7B
 .db    0x3F,0x7F
 .db    0x6B,0xD3
 .db    0x3F,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x6F
 .db    0xAF,0x9B
 .db    0xDB,0xDB
 .db    0xEF,0xDB
 .db    0xDB,0x6F
 .db    0x9E,0x6F
 .db    0x9F,0x6F
 .db    0x9E,0x3F
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x6B
 .db    0x97,0x6B
 .db    0x97,0x3F
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x3F
 .db    0x7F,0xC3
 .db    0x6E,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0xCC,0x6E
 .db    0xF3,0xF3
 .db    0xF2,0xB7
 .db    0x6B,0x3F
 .db    0x3F,0x7A
 .db    0x3F,0x6F
 .db    0x6F,0xAB
 .db    0xDB,0xDB
 .db    0xDB,0xDF
 .db    0xDB,0xDB
 .db    0x6E,0x9E
 .db    0x9E,0x9F
 .db    0x6F,0x3F
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x7B
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xF3
 .db    0xB7,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0x97
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0xF7,0xF3
 .db    0xF7,0x6B
 .db    0x6B,0x3F
 .db    0x7E,0x3F
 .db    0x6E,0x3F
 .db    0xAB,0x6F
 .db    0xDB,0xDB
 .db    0xDF,0xDB
 .db    0xDF,0x9F
 .db    0xAB,0x3F
 .db    0x6F,0x3F
 .db    0x7B,0x3F
 .db    0x7B,0x6B
 .db    0x6B,0x3F
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xB7
 .db    0xB7,0x7B
 .db    0x7B,0x6B
 .db    0xAF,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0x9D
 .db    0x9D,0x6E
 .db    0xF3,0xF7
 .db    0xF3,0x7B
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0x3F
 .db    0x6F,0xAB
 .db    0x9B,0xDB
 .db    0xDB,0xDF
 .db    0x9B,0x6B
 .db    0x6B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xB7
 .db    0xB7,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0x7F
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0xF7,0xF3
 .db    0xF7,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x6E
 .db    0x7E,0x6E
 .db    0x6F,0x6F
 .db    0xAF,0x6F
 .db    0x7B,0x3F
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0x7B
 .db    0x7B,0x6F
 .db    0xBF,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0x9D,0x6E
 .db    0xF2,0xF3
 .db    0x3F,0x3F
 .db    0x3F,0x6E
 .db    0x6E,0x7E
 .db    0x7E,0xAD
 .db    0x3F,0x6F
 .db    0x6B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xF3
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0xBF
 .db    0xAF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0xF2,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x6E
 .db    0x7E,0x6E
 .db    0xAD,0xAD
 .db    0x7E,0x3F
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x3F
 .db    0xEB,0xAF
 .db    0xBF,0x3F
 .db    0x9D,0x6E
 .db    0x9D,0x9D
 .db    0xDD,0x9D
 .db    0x9D,0x6E
 .db    0x3F,0x3F
 .db    0x3F,0x6E
 .db    0x6E,0x7E
 .db    0x7E,0xAD
 .db    0xAD,0xBD
 .db    0x7E,0x7B
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xF3
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xBF
 .db    0xEF,0xEF
 .db    0xBF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x9D,0x9D
 .db    0x3F,0x3F
 .db    0x6E,0x6E
 .db    0x7E,0x6E
 .db    0xAD,0xAD
 .db    0xBD,0xAD
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x3F
 .db    0xFF,0xFF
 .db    0xFF,0xBF
 .db    0xEF,0x3F
 .db    0x9D,0x6E
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x9D,0x6E
 .db    0x3F,0x3F
 .db    0x6E,0x7E
 .db    0x7E,0xAD
 .db    0xAD,0xAD
 .db    0xBD,0xBD
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0xB7,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x3F,0x7F
 .db    0xBF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xBF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0xCC
 .db    0x9D,0x9D
 .db    0x7F,0x3F
 .db    0x7E,0x6E
 .db    0xAD,0xAD
 .db    0xBD,0xAD
 .db    0xEC,0xAD
 .db    0x7B,0x7B
 .db    0xB7,0xB7
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x3F
 .db    0x7F,0x7F
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEF,0x3F
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0xDD,0x9D
 .db    0x9D,0x6E
 .db    0x3F,0x3F
 .db    0x6E,0x7E
 .db    0x7E,0xAD
 .db    0xBD,0xEC
 .db    0xEC,0xAD
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0xB7,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xF3,0xF3
 .db    0xB7,0xF3
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x97,0xA7
 .db    0x97,0x7F
 .db    0x7F,0xAF
 .db    0xBF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x9D,0x9D
 .db    0x7F,0x3F
 .db    0x7E,0x6E
 .db    0xAD,0xAD
 .db    0xEC,0xEC
 .db    0xEC,0xAD
 .db    0x7B,0x7B
 .db    0xB7,0x7B
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xF3,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x3F
 .db    0xA7,0x97
 .db    0xD3,0xD3
 .db    0xD3,0xC3
 .db    0xD3,0x3F
 .db    0xAF,0x7F
 .db    0xEB,0xBF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xEF
 .db    0xEF,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0xCC,0x9D
 .db    0x9D,0x6E
 .db    0x7E,0x6E
 .db    0x6E,0x7E
 .db    0x7E,0xAD
 .db    0xAD,0xBD
 .db    0xBD,0xBD
 .db    0x3F,0x7B
 .db    0x7B,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0x7B,0xB7
 .db    0x7B,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x6B,0xA7
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0x97,0x6B
 .db    0x7F,0xAF
 .db    0xAF,0xEB
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xBF,0x6E
 .db    0x9D,0x9D
 .db    0x9D,0xCC
 .db    0xCC,0x9D
 .db    0x6E,0x6E
 .db    0x7F,0x3F
 .db    0x7E,0x6E
 .db    0xAD,0x7E
 .db    0xBD,0xAD
 .db    0xBD,0x6E
 .db    0x7F,0x3F
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0xB7
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0xB7,0x7B
 .db    0x7B,0x3F
 .db    0x7B,0x3F
 .db    0x6F,0x6E
 .db    0xD7,0xD3
 .db    0xD7,0xD3
 .db    0xD3,0xC3
 .db    0xD3,0x97
 .db    0xD3,0x97
 .db    0xA7,0x6B
 .db    0x7F,0x7F
 .db    0xBF,0xAF
 .db    0xFF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xEF,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0xCC,0x9D
 .db    0x9D,0x6E
 .db    0x7E,0x7F
 .db    0x3F,0x7E
 .db    0x7E,0x7E
 .db    0x7E,0xAD
 .db    0x7E,0x7F
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xB7
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x3F,0x6B
 .db    0x3F,0x6E
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x6B,0xD3
 .db    0xD3,0xD3
 .db    0xC3,0xD3
 .db    0x97,0xA7
 .db    0x97,0x97
 .db    0x6B,0x97
 .db    0x3F,0x7F
 .db    0xAF,0xBF
 .db    0xBF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xAF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0xCC
 .db    0x9D,0x9D
 .db    0x9D,0x6E
 .db    0xBE,0x7E
 .db    0x7E,0x3F
 .db    0x7E,0x6E
 .db    0xAD,0x6E
 .db    0x7E,0x7A
 .db    0xBF,0xBA
 .db    0xBA,0x3F
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x3F
 .db    0xA7,0x6B
 .db    0xD3,0xC3
 .db    0xA7,0x97
 .db    0x6F,0x6F
 .db    0x9F,0x6F
 .db    0x9E,0x6B
 .db    0xD3,0x97
 .db    0xD3,0x97
 .db    0xA7,0x6B
 .db    0x97,0x6B
 .db    0x97,0x3F
 .db    0x3F,0x6F
 .db    0xBF,0xAF
 .db    0xEF,0xBF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xBF,0x6E
 .db    0x9D,0x9D
 .db    0xCC,0xCC
 .db    0xCC,0x9D
 .db    0x9D,0x6E
 .db    0x7F,0x7F
 .db    0x7E,0x3F
 .db    0x6E,0x7E
 .db    0x6E,0x6E
 .db    0x7B,0xBA
 .db    0xBA,0xBF
 .db    0xFA,0xFA
 .db    0x7F,0x7B
 .db    0x3F,0x6B
 .db    0x3F,0x6B
 .db    0x97,0xD3
 .db    0xC3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0x97,0x9E
 .db    0x9E,0x9E
 .db    0x9E,0x6F
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x6B,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x7F,0xAF
 .db    0xBF,0xEF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xAE,0x6E
 .db    0x9D,0x9D
 .db    0x9D,0xCC
 .db    0x9D,0x9D
 .db    0x6E,0x6E
 .db    0xBE,0x7E
 .db    0x7F,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0x3F
 .db    0xBA,0x7F
 .db    0xBF,0xBA
 .db    0xFF,0xFA
 .db    0xFF,0xFF
 .db    0x7B,0x6B
 .db    0x97,0x97
 .db    0xD3,0xC3
 .db    0xD3,0xC3
 .db    0xE7,0xD3
 .db    0xD7,0xD3
 .db    0xD7,0x6F
 .db    0x9E,0x9E
 .db    0x9F,0x6F
 .db    0x6B,0x6B
 .db    0xA7,0x6B
 .db    0x97,0x3F
 .db    0x3F,0x3F
 .db    0x7E,0x3F
 .db    0x3F,0x6E
 .db    0xAF,0x7F
 .db    0xBF,0xBF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xEE,0x6E
 .db    0x9D,0x9D
 .db    0x9D,0x9D
 .db    0xCC,0x9D
 .db    0x9D,0x3F
 .db    0x7E,0x7E
 .db    0x7E,0x7E
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x7F,0xBA
 .db    0xBA,0xFA
 .db    0xFA,0xFF
 .db    0xFF,0xFF
 .db    0x6B,0x97
 .db    0x97,0xD3
 .db    0xC3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0x97
 .db    0x6F,0x9E
 .db    0x9E,0x9E
 .db    0x6B,0x97
 .db    0x6B,0x6B
 .db    0x3F,0x7E
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x6E,0xCE
 .db    0x6E,0xAF
 .db    0xAF,0xBF
 .db    0xEF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0x6E
 .db    0x6E,0x9D
 .db    0x9D,0x9D
 .db    0x9D,0x9D
 .db    0x6E,0x6E
 .db    0x7F,0x3F
 .db    0x7F,0x3F
 .db    0x3F,0x3F
 .db    0x6F,0x3F
 .db    0x7F,0x7F
 .db    0xBF,0xBA
 .db    0xFA,0xFA
 .db    0xFF,0xFA
 .db    0x6B,0x6B
 .db    0xA7,0x97
 .db    0xD3,0xC3
 .db    0xD7,0xD3
 .db    0xD3,0xC3
 .db    0xD3,0xC3
 .db    0xD3,0x97
 .db    0x6B,0x6E
 .db    0x9E,0x3F
 .db    0x97,0x6B
 .db    0x6B,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0xCE,0x9E
 .db    0x9E,0x7F
 .db    0xBF,0xAF
 .db    0xEF,0xEF
 .db    0xFF,0xFF
 .db    0xFF,0xAE
 .db    0x6E,0x6E
 .db    0x9D,0x6E
 .db    0x9D,0x6E
 .db    0x6E,0x6F
 .db    0x3F,0x7E
 .db    0x3F,0x3F
 .db    0x6F,0x6F
 .db    0x3F,0x3F
 .db    0x3F,0xBA
 .db    0x7F,0xBB
 .db    0xBF,0xFA
 .db    0xBF,0xFA
 .db    0x6B,0x97
 .db    0x97,0x97
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0xD3,0xD3
 .db    0x97,0x97
 .db    0x97,0x97
 .db    0x97,0x6B
 .db    0x6B,0x6B
 .db    0x3F,0x7E
 .db    0x7E,0x7E
 .db    0x3F,0x3F
 .db    0x3F,0x3F
 .db    0x3F,0x6F
 .db    0x9E,0x9E
 .db    0x9E,0x7F
 .db    0xAB,0xBF
 .db    0xAF,0xEF
 .db    0xEF,0xFF
 .db    0xEF,0xFF
 .db    0xAF,0x6E
 .db    0x6E,0x6E
 .db    0x6E,0x6E
 .db    0x3F,0x9E
 .db    0x3F,0x3F
 .db    0x3F,0x6E
 .db    0xAF,0x6F
 .db    0x6F,0x3F
 .db    0x6B,0x7A
 .db    0xBA,0x7F
 .db    0xBF,0xBA
 .db    0xBF,0xBA
 .db    0x7B,0x6B
 .db    0x97,0x97
 .db    0xD3,0x97
 .db    0xD3,0x97
 .db    0xD3,0x97
 .db    0xA7,0x97
 .db    0xA7,0x6B
 .db    0x97,0x6B
 .db    0x6B,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x7E,0x3F
 .db    0x6E,0x6E
 .db    0x9E,0x9E
 .db    0x9E,0x3F
 .db    0xAF,0x7F
 .db    0xBF,0xAF
 .db    0xEF,0xEB
 .db    0xEF,0xBF
 .db    0xEF,0xAF
 .db    0xAF,0x3F
 .db    0x7F,0x3F
 .db    0x6F,0x6F
 
